/* 
docinfo.c 
ALICE V 2.0, January 1993
library functions for displaying document information
(C) Ralf Kaufmann 1993
used C compiler: Pure C 
*/ 
 
/* Includefiles */ 
 
#include <gem.h> 
#include <stdio.h> 
#include "language.h" 
#include "prvdef.h" 
#include "mewidi.h" 
#include "messages.h" 
#include "scancode.h" 
#include "structs.h" 
#include "rsc.h" 
 
 
/* References to global data defined elsewhere  */ 
 
extern  short     hzeich; 
extern  WIND_DATA windows[]; 
extern  OBJECT    *dial_info; 
extern  char    	text[]; 

// Funktionsprototypen
long get_byte_size(int w_index);
short get_index_from_handle(short w_handle); 
long get_max_line_length(int w_index);
short handle_dial(OBJECT *dial_tree, short start_obj); 
int number_of_pages(int w_index);
int own_top_wind(void); 
int top_wind(void); 

/**********************/ 
/* Start of routines  */ 
/**********************/ 
 
 
/* main routine for displaying document information */
 
void doc_info(void) 
{ 
  long    num_lines, bytes; 
  short   length, num_pages, w_index;
  TEDINFO	*ted_info; 

  w_index = get_index_from_handle(top_wind()); 
  if (w_index == -1 || !own_top_wind())		return;
  num_lines = windows[w_index].doc_length / hzeich; 
  num_pages = number_of_pages(w_index);
  length = get_max_line_length(w_index);
  bytes = get_byte_size(w_index); 
  ted_info = dial_info[PAGES].ob_spec.tedinfo; 
  sprintf(text, "%6d", num_pages); 
  strcpy(ted_info->te_ptext, text); 
  ted_info = dial_info[LINES].ob_spec.tedinfo; 
  sprintf(text, "%6ld", num_lines); 
  strcpy(ted_info->te_ptext, text); 
  ted_info = dial_info[MAXLEN].ob_spec.tedinfo; 
  sprintf(text, "%6d", length); 
  strcpy(ted_info->te_ptext, text); 
  ted_info = dial_info[CHARS].ob_spec.tedinfo; 
  sprintf(text, "%6ld", bytes); 
  strcpy(ted_info->te_ptext, text); 
  handle_dial(dial_info, 0); 
  return;
}



/* end of file docinfo.c          */


