/* 
gem.c 
ALICE V 2.0, January 1993
library functions for GEM initialization and exit 
(C) Ralf Kaufmann 1993 
used C compiler: Pure C 
*/ 
 
/* Includefiles */ 
 
#define __GEMLIB_OLDNAMES
#include <gem.h> 
#include <osbind.h> 
#include <stdio.h> 
#include "language.h" 
#include "prvdef.h" 
#include "mewidi.h" 
#include "messages.h" 
#include "scancode.h" 
#include "structs.h" 
#include "rsc.h" 
 
/* References to global data defined elsewhere  */ 
 
extern  short		ap_id, VDIhandle; 
extern  MFDB    screen; 
extern  OBJECT  *menu_tree; 
extern  OBJECT  *dial_about, *dial_help, *dial_print, *dial_options; 
extern  OBJECT  *dial_search, *dial_replace, *dial_gotoli; 
extern  OBJECT  *dial_info, *dial_selebuf; 
extern  OBJECT  *dial_repl_info, *dial_gotopa; 
extern  OBJECT  *dial_helpfi, *dial_helpms;
extern  OBJECT  *dial_helpbl, *dial_helpwi;
extern  OBJECT  *dial_pinfo;

extern  int       tab_size, tab_size_cfg, backup, backup_cfg;
extern  int       clocky, clocky_cfg, showcr, showcr_cfg;
extern  int       showpos, showpos_cfg;
extern  int       showpos, showpos_cfg;
extern  int       showpos, showpos_cfg;
extern  int       page_length, page_length_cfg;
extern  int       left_margin, left_margin_cfg;
extern  int       header, header_cfg, lines, lines_cfg;
extern  int       line_len, line_len_cfg, eol_warn, eol_warn_cfg; 
extern	int				sea_direct, sea_direct_cfg;
extern	int				sea_case, sea_case_cfg;
extern	int				sea_start, sea_start_cfg;
extern	int				repl_case, repl_case_cfg;
extern	int				repl_verify, repl_verify_cfg;
extern	int				repl_start, repl_start_cfg;

extern  char      sea_str[], sea_str_cfg[];
extern  char      repl_str[], repl_str_cfg[];
extern  char      replby_str[], replby_str_cfg[];
 
extern  WIND_DATA windows []; 
extern  BUFFER    buffers []; 
 
extern short work_in[], work_out[]; 

/*  Declare VDI globals */ 
short	bbox, hbox, bzeich, hzeich;

// Function-Prototypes
void display_time(short flag); 
void gem_exit(int rsrc);
int init_buffer(int b_index);
void put_message(int msg_nr);

/**********************/ 
/* Start of routines  */ 
/**********************/ 
 
 
 
int gem_init(void) 
{ 
  short		i, j, phys_handle; 
  TEDINFO *ted_info; 
  char    text[MAX_LINE];
  
  if ((ap_id = appl_init ()) == -1)  return (ap_id); 

  MOUSE_IS_ARROW; 
 
/*  if (Getrez () == 0)         /* low resolution does not make sense */ 
/*  { 
/*    put_message (NO_LOW_REZ); 
/*    gem_exit (FALSE); 
/*  } 
*/
 
  /*  get handle for the workstation */ 
 
  phys_handle = graf_handle (&bzeich, &hzeich, &bbox, &hbox); 
 
  /* open the virtual workstation (in addition to the       */ 
  /* already opened physical one). a workstation is just an */ 
  /* environment defining attributes for the VDI functions. */ 
  /* there may be only one workstation for each device      */ 
 
  for (i = 0; i < 10; i++)  work_in[i] = 1; 
  work_in[10] = 2; 
  v_opnvwk (work_in, &phys_handle, work_out); 
  if (phys_handle == 0) return (FALSE); 
  VDIhandle = phys_handle; 
 
  /* here comes the stuff for the screen handling...              */ 
 
  screen.fd_w = (int) (work_out[0] + 1); /* width in pixels      */ 
  screen.fd_h = (int) (work_out[1] + 1); /* height in pixels ... */ 
  screen.fd_wdwidth = (int) (screen.fd_w / WORD_LENGTH); 
                                          /* ...the same in words */
         										/* low resolution does not make sense */
  if (screen.fd_w < 640 || screen.fd_h < 400)
  { 
    put_message (NO_LOW_REZ); 
    gem_exit (FALSE); 
  } 

  screen.fd_stand   = 0; 
  screen.fd_addr    = Physbase(); 
 
  vq_extnd (VDIhandle, 1, work_out); /* inquire extended parameters  */ 
  screen.fd_nplanes = work_out[4]; 
 
  vst_effects (VDIhandle, 0);                          /* normal text  */
  vst_alignment (VDIhandle, 0, 5, &i, &j); /* This alignement is very  */ 
                                        /* important for the text   */ 
                                        /* display in the windows.  */ 
                                        /* So be carefull ...       */ 
 
  vsf_interior (VDIhandle, 2);     /* dotted interior for block marks  */ 
  vsf_style (VDIhandle, 2); 
  vsf_perimeter (VDIhandle, 0);                  /* no border for bars */ 
  vswr_mode (VDIhandle, MD_REPLACE);         /* write mode is replace  */ 
   
  if (!rsrc_load(RSC_FILE)) 
  { 
    put_message(NO_RSC); 
		gem_exit (FALSE);
  } 
 
  /* get the resource adresses  */ 
 
  rsrc_gaddr (R_TREE, MENU01,   &menu_tree); 
  rsrc_gaddr (R_TREE, DABOUT,   &dial_about); 
  rsrc_gaddr (R_TREE, DHELP,    &dial_help); 
  rsrc_gaddr (R_TREE, DHELPFI,  &dial_helpfi); 
  rsrc_gaddr (R_TREE, DHELPMS,  &dial_helpms); 
  rsrc_gaddr (R_TREE, DHELPBL,  &dial_helpbl); 
  rsrc_gaddr (R_TREE, DHELPWI,  &dial_helpwi); 
  rsrc_gaddr (R_TREE, DPRINT,   &dial_print); 
  rsrc_gaddr (R_TREE, DOPTIONS, &dial_options); 
  rsrc_gaddr (R_TREE, DSEARCH,  &dial_search); 
  rsrc_gaddr (R_TREE, DREPLACE, &dial_replace); 
  rsrc_gaddr (R_TREE, DGOTOLI,  &dial_gotoli); 
  rsrc_gaddr (R_TREE, DGOTOPA,  &dial_gotopa); 
  rsrc_gaddr (R_TREE, DINFO,    &dial_info); 
  rsrc_gaddr (R_TREE, DSELEBUF, &dial_selebuf); 
  rsrc_gaddr (R_TREE, DREPLINF, &dial_repl_info); 
 
  ted_info = dial_search[SEASTRG].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, sea_str_cfg); 

  ted_info = dial_replace[REPLSTRG].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, repl_str_cfg); 

  ted_info = dial_replace[REPLBYST].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, replby_str_cfg); 
 
  ted_info = dial_info[PAGES].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_info[LINES].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_info[MAXLEN].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_info[CHARS].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_gotoli[LINEGOTO].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_gotopa[PAGEGOTO].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_selebuf[BUFNAM1].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_selebuf[BUFNAM2].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_selebuf[BUFNAM3].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_selebuf[BUFNAM4].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_selebuf[BUFNAM5].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_selebuf[BUFNAM6].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_selebuf[BUFNAM7].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_selebuf[BUFNAM8].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_selebuf[BUFNAM9].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_selebuf[BUFNAM10].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ""); 

  ted_info = dial_print[PAGELEN].ob_spec.tedinfo; 
  sprintf (text, "%3d", page_length_cfg); 
  strcpy (ted_info->te_ptext, text); 

  ted_info = dial_print[LEFTMAR].ob_spec.tedinfo; 
  sprintf (text, "%2d", left_margin_cfg); 
  strcpy (ted_info->te_ptext, text); 
 
  /* make sure that the version number and the author's   */
  /* copyright are not modified by modifying the RSC file */
  
  ted_info = dial_about[VERSION].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ALICE_VERSION);       /* version    */
 
  ted_info = dial_about[AUTHOR].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, ALICE_AUTHOR);   		/* author  */
 
  ted_info = dial_about[COPYRITE].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, "Copyright \275 1992/93                2003"); 
  																									/* copyright  */
 
   
  /* set a few defaults  */ 
   
	if (sea_start_cfg)
	{	
	  objc_change (dial_search, SEATOP, 0, 0, 0, 0, 0, SELECTED, 0); 
	                                      /* search starts at the top */ 
	}
	else
	{
	  objc_change (dial_search, SEACURS, 0, 0, 0, 0, 0, SELECTED, 0); 
	                                   /* search starts at the cursor */ 
	}
	if (sea_direct_cfg)
	{
	  objc_change (dial_search, SEAFORW, 0, 0, 0, 0, 0, SELECTED, 0); 
	                                   /* search direction is forward */ 
  }
  else
  {
	  objc_change (dial_search, SEABACKW, 0, 0, 0, 0, 0, SELECTED, 0); 
	                                /* search direction is backward */ 
  }

  if (sea_case_cfg)
  {
	  objc_change (dial_search, SCASEYES, 0, 0, 0, 0, 0, SELECTED, 0); 
	}
	else
	{
	  objc_change (dial_search, SCASENO, 0, 0, 0, 0, 0, SELECTED, 0); 
	}

	if (repl_case_cfg)
	{
  	objc_change (dial_replace, RCASEYES, 0, 0, 0, 0, 0, SELECTED, 0); 
  }
  else
  {
  	objc_change (dial_replace, RCASENO, 0, 0, 0, 0, 0, SELECTED, 0); 
  }

  if (repl_start_cfg)
  {
  	objc_change (dial_replace, REPLTOP, 0, 0, 0, 0, 0, SELECTED, 0); 
                                  /* replacement starts at the top  */ 
  }
  else
  {
  	objc_change (dial_replace, REPLCURS, 0, 0, 0, 0, 0, SELECTED, 0); 
                                /* replacement starts at the cursor */ 
  }

  if (repl_verify_cfg)
	{
  	objc_change (dial_replace, REPLVYES, 0, 0, 0, 0, 0, SELECTED, 0); 
                                   /* verify is on for replacement  */
  }
  else
	{
  	objc_change (dial_replace, REPLVNO, 0, 0, 0, 0, 0, SELECTED, 0); 
  }
                        
  objc_change (dial_selebuf, BUF1,     0, 0, 0, 0, 0, SELECTED, 0); 
                                   /* buffer 1 is the default       */ 
  if (header)
  {
    objc_change (dial_print, HEADYES,  0, 0, 0, 0, 0, SELECTED, 0); 
  }
  else
  {
    objc_change (dial_print, HEADNO,   0, 0, 0, 0, 0, SELECTED, 0); 
  }
  if (lines)
  {
    objc_change (dial_print, LINEYES,  0, 0, 0, 0, 0, SELECTED, 0); 
  }
  else
  {
    objc_change (dial_print, LINENO,   0, 0, 0, 0, 0, SELECTED, 0); 
  }
   
  menu_bar (menu_tree, MN_SHOW_MENU);        /* display menu bar    */ 
  menu_ienable (menu_tree, ICLOSE,   FALSE); /* disable close       */ 
  menu_ienable (menu_tree, IRDFILFI, FALSE); /* disable include     */ 
  menu_ienable (menu_tree, ICLOSALL, FALSE); /* disable close all   */ 
  menu_ienable (menu_tree, IDOCINFO, FALSE); /* disable doc info    */ 
  menu_ienable (menu_tree, IGOTOLI,  FALSE); /* disable goto line   */ 
  menu_ienable (menu_tree, IGOTOPA,  FALSE); /* disable goto page   */ 
  menu_ienable (menu_tree, IBACK,    FALSE); /* disable backup      */ 
  menu_ienable (menu_tree, IBACKAS,  FALSE); /* disable backup as   */ 
  menu_ienable (menu_tree, ISAVE,    FALSE); /* disable save        */ 
  menu_ienable (menu_tree, ISAVEAS,  FALSE); /* disable save as     */ 
  menu_ienable (menu_tree, IFIPRINT, FALSE); /* disable print file  */ 
  menu_ienable (menu_tree, ISEARCH,  FALSE); /* disable search      */ 
  menu_ienable (menu_tree, IREPL,    FALSE); /* disable replace     */ 
  menu_ienable (menu_tree, IREPSEAR, FALSE); 
                                           /* disable repeat search */ 
  menu_ienable (menu_tree, IBLSTART, FALSE); /* disable start block */ 
  menu_ienable (menu_tree, IBLEND,   FALSE); /* disable end block   */ 
  menu_ienable (menu_tree, IBLCANC,  FALSE); /* disable cancel      */ 
  menu_ienable (menu_tree, ICLBUFF,  FALSE); 
                                           /* disable clear buffer  */ 
  menu_ienable (menu_tree, IBLCUT,   FALSE); /* disable cut block   */ 
  menu_ienable (menu_tree, IBLCOPY,  FALSE); /* disable copy block  */ 
  menu_ienable (menu_tree, IBLPASTE, FALSE); /* disable paste block */ 
  menu_ienable (menu_tree, IBLDELE,  FALSE); 
                                           /* disable delete block  */ 
 
  display_time (clocky);  
  for (i = 0; i < WD_MAX_BUFFERS+1; i++) init_buffer (i); 
  MOUSE_IS_ARROW; 
  graf_mouse (0, 0); 
  return (TRUE); 
}                             /* end function gem_init  */ 
 
 
 
 
void gem_exit(int rsrc) 
//int   rsrc;                   /* free resources ? */ 
{ 
  int i; 
 
 
  display_time (FALSE); 
 	MOUSE_IS_ARROW; 
  if (rsrc) 
  { 
	  for (i = 0; i < WD_MAX_BUFFERS+1; i++) init_buffer (i); 
    menu_bar (menu_tree, MN_HIDE_MENU); /* delete the menu bar  */ 
    rsrc_free();                        /* free all resources   */ 
	  v_clsvwk (VDIhandle);        /* close the virtual workstation  */ 
  	appl_exit ();             /* farewell to GEM                */ 
  } 
  exit (0);                   /* well, that was it...           */ 
}                             /* end function gem_exit          */ 
 
 
 
/* end of file gem.c  */ 
 
