/* 
keybd.c 
ALICE V 2.0, January 1993
library functions for keyboard handling 
(C) Ralf Kaufmann 1993 
used C compiler: Pure C 
*/ 
 
/* Includefiles */ 
 
#define __GEMLIB_OLDNAMES
# include <gem.h> 
# include <osbind.h> 
# include <stdio.h> 
# include <stdlib.h> 
# include <string.h> 
# include "language.h" 
# include "prvdef.h" 
# include "mewidi.h" 
# include "messages.h" 
# include "scancode.h" 
# include "structs.h" 
# include "rsc.h" 

/* References to global data defined elsewhere  */ 

extern  WIND_DATA   windows[]; 
extern  short       ap_id, VDIhandle; 
extern  short       hzeich, bzeich; 
extern  int         tab_size, closeall, prgquit; 
extern  OBJECT      *menu_tree; 

// Function-Prototypes
short block_set(short w_index); 
void cap_check(int w_index); 
void clear_block_flags(short w_index); 
LINE_DESC *create_list_element(void);
short cursor(short w_handle, short mode); 
short cursor_visible_check(short w_index); 
short do_redraw(short w_handle, short x, short y, short w, short h, 
								short clear); 
void find_next_word(int w_index, long *next_curs_x, long *next_curs_y);
short full_redraw(short w_handle, short clear); 
int get_free_index(void); 
short get_index_from_handle(short w_handle); 
int handle_shortcut(int key);
short HighWord(char *str);
int line_length(int  w_index, long number); 
LINE_DESC *line_ptr(int w_index, size_t number); 
long max(long a, long b);
long min(long a, long b);
void put_message(int msg_nr);
void rcopy(short xs, short ys, short ws, short hs, short xd, short yd, 
					 short mode);
void set_slider_pos(short w_handle);
void set_slider_size(short w_handle); 
int top_wind(void); 

/**********************/ 
/* Start of routines  */ 
/**********************/ 

 
int handle_keybd(int key) 
//int   key; 
{ 
  unsigned char scan_hi, scan_lo; 

  short       w_index, w_handle; 
  int         control, jmc;                          /* just move cursor ? */ 
  long        i, j, a, b, x, y, w, h; 
  long        curs_x, curs_y, doc_h, doc_w, start_x, start_y; 
  long        start_x_new, start_y_new, len_x; 
  long        slider, wind_w, wind_h, redraw_line, from_line; 
  long        doc_x_save, doc_y_save, doc_l_save, doc_w_save; 
  long        curs_y_save, help; 
  int         send_buffer[MSG_BUFFER];
  int					shift = 0, delete_space, backspace, insert; 
  int         q_curs_down, q_curs_up, lines_copy, lines_redraw; 
  LINE_DESC   *p, *q, *next; 
 	
  if (closeall 																	|| 
  		prgquit 																	||
  		(menu_tree[TDESK].ob_state & SELECTED) 		||
			(menu_tree[TFILE].ob_state & SELECTED) 		||
			(menu_tree[TBLOCK].ob_state & SELECTED) 	||
			(menu_tree[TSEARCH].ob_state & SELECTED)	|| 
			(menu_tree[TEXTRAS].ob_state & SELECTED) 	||
			(menu_tree[THELP].ob_state & SELECTED))	
	{
		return (TRUE);
  }
  memset (send_buffer, (int) 0, (long) MSG_BUFFER); 
  send_buffer[1] 	= ap_id; 
  send_buffer[2] 	= 0; 
  scan_lo 				= key & 0x00FF; 
  scan_hi 				= (key >> 8) & 0x00FF; 

  if ((scan_hi == HI_ALT_O 	&& scan_lo == LO_ALT_O) 	||
  		(scan_hi == HI_ALT_N 	&& scan_lo == LO_ALT_N)		||
			(scan_hi == HI_ALT_P 	&& scan_lo == LO_ALT_P)  	||
			(scan_hi == HI_ALT_B 	&& scan_lo == LO_ALT_B)  	||
			(scan_hi == HI_ALT_K 	&& scan_lo == LO_ALT_K)  	||
			(scan_hi == HI_ALT_S 	&& scan_lo == LO_ALT_S)  	||
			(scan_hi == HI_ALT_G 	&& scan_lo == LO_ALT_G)  	||
			(scan_hi == HI_ALT_I 	&& scan_lo == LO_ALT_I)  	||
			(scan_hi == HI_ALT_C 	&& scan_lo == LO_ALT_C)  	||
			(scan_hi == HI_ALT_U 	&& scan_lo == LO_ALT_U)  	||
			(scan_hi == HI_SF10   && scan_lo == LO_SF10)  	|| 
      (scan_hi == HI_CTRL_Q && scan_lo == LO_CTRL_Q)	||
  		(scan_hi == HI_CTRL_X && scan_lo == LO_CTRL_X)  ||
			(scan_hi == HI_ALT_M 	&& scan_lo == LO_ALT_M) 	||
			(scan_hi == HI_ALT_L 	&& scan_lo == LO_ALT_L) 	||
			(scan_hi == HI_ALT_R 	&& scan_lo == LO_ALT_R)		||
			(scan_hi == HI_ALT_E 	&& scan_lo == LO_ALT_E) 	||
			(scan_hi == HI_CTRL_D && scan_lo == LO_CTRL_D)	|| 
			(scan_hi == HI_CTRL_C && scan_lo == LO_CTRL_C)	||
			(scan_hi == HI_CTRL_R && scan_lo == LO_CTRL_R)	||
			(scan_hi == HI_CTRL_V && scan_lo == LO_CTRL_V)  ||
			(scan_hi == HI_CTRL_L && scan_lo == LO_CTRL_L)  ||
			(scan_hi == HI_CTRL_P && scan_lo == LO_CTRL_P)	||
			(scan_hi == HI_ALT_T 	&& scan_lo == LO_ALT_T)		||
			(scan_hi == HI_ALT_D 	&& scan_lo == LO_ALT_D)		||
			(scan_hi == HI_ALT_A 	&& scan_lo == LO_ALT_A)		||
			(scan_hi == HI_HELP) 														||
      (scan_hi == HI_CTRL_K && scan_lo == LO_CTRL_K)	||
			(scan_hi == HI_CTRL_T && scan_lo == LO_CTRL_T)	||
			(scan_hi == HI_CTRL_O && scan_lo == LO_CTRL_O)	||
			(scan_hi == HI_CTRL_M && scan_lo == LO_CTRL_M)	||
			(scan_hi == HI_CTRL_I && scan_lo == LO_CTRL_I))
	{	
		return (handle_shortcut (key));	 
  } 
  if ((w_handle = top_wind ()) == -1) return (TRUE); 
  w_index = get_index_from_handle (w_handle); 
  if (scan_hi == HI_F1 && scan_lo == LO_F1) 
  { 
    scan_hi = HI_SCUDOWN;           /* shift cursor down   */ 
    scan_lo = LO_SCUDOWN; 
  } 
  if (scan_hi == HI_F2 && scan_lo == LO_F2) 
  { 
    scan_hi = HI_SCUUP;             /* shift cursor up     */ 
    scan_lo = LO_SCUUP; 
  } 
  if ((scan_hi == HI_F3     && scan_lo == LO_F3) 			|| 
      (scan_hi == HI_CTRL_S && scan_lo == LO_CTRL_S)	||
			(scan_hi == HI_F4     && scan_lo == LO_F4) 			||
      (scan_hi == HI_CTRL_E && scan_lo == LO_CTRL_E)	||
			(scan_hi == HI_CTRL_F && scan_lo == LO_CTRL_F) 	||
			(scan_hi == HI_F10    && scan_lo == LO_F10) 		||
      (scan_hi == HI_CTRL_A && scan_lo == LO_CTRL_A)	||
			(scan_hi == HI_SF3 		&& scan_lo == LO_SF3)			||
			(scan_hi == HI_SF4 		&& scan_lo == LO_SF4))
	{
		return (handle_shortcut (key));
	} 
  redraw_line  = from_line = -1; 
  delete_space = backspace = insert = FALSE; 
  q_curs_down  = q_curs_up = FALSE; 
  graf_mouse(M_ON, NULL);
  cursor(w_handle, 0);                 					/* ... and the text cursor  */ 
  if (scan_hi == HI_CLRHOME && scan_lo == LO_CLRHOME) 
  {                                             /* 1. if start      */ 
    if (windows[w_index].doc_x  == 0   &&   /* already at the top ? */ 
        windows[w_index].doc_y  == 0   &&   /* -> goto end of text  */ 
        windows[w_index].curs_x == 1   && 
        windows[w_index].curs_y == 1) 
    { 
      windows[w_index].doc_y = 
      										max((long)0, (long)(windows[w_index].doc_length - 
                     					windows[w_index].work.g_h)); 
      windows[w_index].curs_y = windows[w_index].doc_length / hzeich; 
    } 
    else 
    { 
      windows[w_index].doc_x    = 0; 
      windows[w_index].doc_y    = 0; 
      windows[w_index].curs_x   = 1; 
      windows[w_index].curs_xs  = windows[w_index].curs_x; 
      windows[w_index].curs_y   = 1; 
    } 
    slider  = TRUE; 
    jmc     = FALSE; 
  } 
  else if (scan_hi == HI_SCLRHOME && scan_lo == LO_SCLRHOME) 
                                           /* key = shift Clr Home */ 
  {                   /* initiates a redraw of the active window   */ 
		clear_block_flags (w_index);
    cap_check (w_index);
    menu_ienable (menu_tree, IOPEN, (get_free_index () != -1)); 
    															/* check for more window handles	*/
    slider  = TRUE; 
    jmc     = FALSE; 
  } 
  else if (block_set (w_index)                                    && 
           !(scan_hi == HI_ESC        && scan_lo == LO_ESC)       && 
           !(scan_hi == HI_SCUUP      && scan_lo == LO_SCUUP)     && 
           !(scan_hi == HI_SCUDOWN    && scan_lo == LO_SCUDOWN)   && 
           !(scan_hi == HI_CUUP       && scan_lo == LO_CUUP)      && 
           !(scan_hi == HI_CUDOWN     && scan_lo == LO_CUDOWN)    && 
           !(scan_hi == HI_CURIGHT    && scan_lo == LO_CURIGHT)   && 
           !(scan_hi == HI_CULEFT     && scan_lo == LO_CULEFT)    && 
           !(scan_hi == HI_CTCURIGHT  && scan_lo == LO_CTCURIGHT) && 
           !(scan_hi == HI_CTCULEFT   && scan_lo == LO_CTCULEFT)) 
  { 
    /* make sure that an existing block is not edited as this might */ 
    /* cause some problems with the stored block marks (and I don't */ 
    /* feel like updating the block marks while the user presses    */ 
    /* editing keys: this job is left as an exercise to the reader) */ 
    cursor(w_handle, 1); 
    graf_mouse(M_ON, NULL); 
    put_message (CANCEL_BLMARKS); 
    return (TRUE); 
  } 
  else if (!cursor_visible_check(w_index)                     && 
           !(scan_hi == HI_SCUUP    && scan_lo == LO_SCUUP)   && 
           !(scan_hi == HI_SCUDOWN  && scan_lo == LO_SCUDOWN)) 
  { 
    curs_y  = (windows[w_index].curs_y - 1) * hzeich; 
    doc_h   = windows[w_index].work.g_h; 
    windows[w_index].doc_y = max((long)(curs_y - doc_h/2), (long)0); 
    curs_x  = (windows[w_index].curs_x - 1) * bzeich; 
    doc_w   = windows[w_index].work.g_w; 
    if (!(windows[w_index].doc_x == 0 && curs_x + 1 <= doc_w)) 
    { 
      windows[w_index].doc_x = max((long)(curs_x - doc_w/2), (long)0); 
    } 
    slider = TRUE; 
    jmc = FALSE; 
  } 
  else 
  { 
    jmc         = TRUE; 
    slider      = FALSE; 
    doc_x_save  = windows[w_index].doc_x; 
    doc_y_save  = windows[w_index].doc_y; 
    doc_l_save  = windows[w_index].doc_length; 
    doc_w_save  = windows[w_index].doc_width; 
    switch (scan_hi) 
    { 
      case HI_CUDOWN: 
        switch (scan_lo) 
        { 
          case LO_SCUDOWN:                   /* shift cursor down  */ 
                  send_buffer[0] = WM_ARROWED; 
                  send_buffer[3] = w_handle; 
                  send_buffer[4] = W_DNPAGE; 
                  appl_write(ap_id, (short)sizeof(send_buffer), send_buffer); 
                  cursor(w_handle, 1); 
  								graf_mouse(M_ON, NULL);
                  return (TRUE); 
          case LO_CUDOWN:                         /* cursor down  */ 
                  windows[w_index].curs_y++; 
                  if (windows[w_index].curs_y > 
                      windows[w_index].doc_length / hzeich) 
                  { 
                    windows[w_index].curs_y = 
                    										windows[w_index].doc_length / hzeich; 
                    cursor(w_handle, 1); 
  									graf_mouse(M_ON, NULL);
                    return (TRUE); 
                  } 
                  len_x   = line_length (w_index, 
                                         windows[w_index].curs_y); 
                  start_x = windows[w_index].doc_x / bzeich; 
                  start_y = windows[w_index].doc_y / hzeich; 
                  wind_w  = windows[w_index].work.g_w / bzeich; 
                  wind_h  = windows[w_index].work.g_h / hzeich; 
                  windows[w_index].curs_x = 
                    min ((long) windows[w_index].curs_xs, 
                         (long) len_x); 
                  if ((windows[w_index].curs_x <= start_x) || 
                      (windows[w_index].curs_x >= start_x + wind_w)) 
                  { 
                    windows[w_index].doc_x  = 
                      windows[w_index].curs_x - 
                        windows[w_index].work.g_w / bzeich; 
                    windows[w_index].doc_x *= bzeich; 
                    windows[w_index].doc_x = 
                      max ((long) windows[w_index].doc_x, (long) 0); 
                  } 
                  start_y = windows[w_index].doc_y / hzeich; 
                  doc_h   = windows[w_index].work.g_h / hzeich; 
                  if (windows[w_index].curs_y > start_y + doc_h) 
                  { 
                    lines_copy = windows[w_index].work.g_h / hzeich; 
                    lines_copy /= 2; 
                    h = lines_copy * hzeich; 
                    lines_redraw = 
                     (int) ((windows[w_index].work.g_h - h) / hzeich); 
                    windows[w_index].doc_y += hzeich * lines_redraw; 
                    a = windows[w_index].doc_length - 
                        windows[w_index].work.g_h; 
                    a = max (a, 0); 
                    b = windows[w_index].doc_y; 
                    windows[w_index].doc_y = min (a, b); 
                    if (windows[w_index].doc_x == 0) 
                    { 
                      if (doc_y_save + 
                          windows[w_index].work.g_h + 
                          windows[w_index].work.g_h / 2 <= 
                          windows[w_index].doc_length) 
                      { 
                        from_line   = windows[w_index].curs_y - 2; 
                        q_curs_down = TRUE;   /* quick redraw */ 
                      } 
                      break;    /* full redraw  */ 
                    } 
                    else 
                    { 
                      send_buffer[0] = WM_ARROWED; 
                      send_buffer[3] = w_handle; 
                      send_buffer[4] = W_DNLINE; 
                      appl_write(ap_id, (short)sizeof(send_buffer), 
                      					 send_buffer); 
                      break;  
                        /* perform the (full) redraw first, deal  */ 
                        /* with the downline message later on     */ 
                    } 
                  } 
                  break; 
          default: 
                  break; 
        }                                        /* 2. switch end   */ 
        break; 
      case HI_CUUP: 
        switch (scan_lo)                       /* 2. switch start   */ 
        { 
          case LO_SCUUP:                       /* shift cursor up   */ 
              send_buffer[0] = WM_ARROWED; 
              send_buffer[3] = w_handle; 
              send_buffer[4] = W_UPPAGE; 
              appl_write(ap_id, (short)sizeof(send_buffer), send_buffer); 
              cursor(w_handle, 1); 
  						graf_mouse(M_ON, NULL);
              return (TRUE); 
          case LO_CUUP:                              /* cursor up   */ 
              windows[w_index].curs_y--; 
              if (windows[w_index].curs_y < 1) 
              { 
                windows[w_index].curs_y = 1; 
                cursor(w_handle, 1); 
  							graf_mouse(M_ON, NULL);
                return (TRUE); 
              } 
              len_x   = line_length (w_index, 
                                     windows[w_index].curs_y); 
              start_x = windows[w_index].doc_x / bzeich; 
              wind_w  = windows[w_index].work.g_w / bzeich; 
              windows[w_index].curs_x = 
                min ((long) windows[w_index].curs_xs, 
                     (long) len_x); 
              if ((windows[w_index].curs_x <= start_x) || 
                  (windows[w_index].curs_x >= start_x + wind_w)) 
              { 
                windows[w_index].doc_x  = 
                  windows[w_index].curs_x - 
                    windows[w_index].work.g_w / bzeich; 
                windows[w_index].doc_x *= bzeich; 
                windows[w_index].doc_x = 
                  max ((long) windows[w_index].doc_x, (long) 0); 
              } 
              start_y = windows[w_index].doc_y / hzeich; 
              doc_h   = windows[w_index].work.g_h / hzeich; 
              if (windows[w_index].curs_y <= start_y ) 
              { 
                lines_copy = windows[w_index].work.g_h / hzeich; 
                lines_copy /= 2; 
                h = lines_copy * hzeich; 
                lines_redraw = 
                  (int) ((windows[w_index].work.g_h - h) / hzeich); 
                windows[w_index].doc_y -= hzeich * lines_redraw; 
                a = windows[w_index].doc_y; 
                windows[w_index].doc_y = max (a, 0); 
                if (windows[w_index].doc_x == 0) 
                { 
                  if (doc_y_save - 
                      windows[w_index].work.g_h / 2 > 0) 
                  { 
                    from_line = windows[w_index].curs_y - 1; 
                    q_curs_up = TRUE;   /* quick redraw */ 
                  } 
                  break;    /* full redraw  */ 
                } 
                else 
                { 
                  send_buffer[0] = WM_ARROWED; 
                  send_buffer[3] = w_handle; 
                  send_buffer[4] = W_UPLINE; 
                  appl_write(ap_id, (short)sizeof(send_buffer), send_buffer); 
                  break;  /* perform the (full) redraw first, deal  */ 
                          /* with the downline message later on     */ 
                } 
              } 
              break; 
          default: 
              break; 
        }                                        /* 2. switch end  */ 
        break; 
      case HI_CURIGHT:                             /* cursor right */ 
              windows[w_index].curs_x++; 
              windows[w_index].curs_xs  = windows[w_index].curs_x; 
              curs_x  = windows[w_index].curs_x; 
              len_x   = line_length (w_index, windows[w_index].curs_y); 
              if (curs_x > len_x) 
              {                                   /* 1. if start  */ 
                if (windows[w_index].curs_y >= 
                    windows[w_index].doc_length / hzeich) 
                { 
                  windows[w_index].curs_x--; 
                  windows[w_index].curs_xs  = windows[w_index].curs_x; 
                  cursor(w_handle, 1); 
  								graf_mouse(M_ON, NULL);
                  return (TRUE); 
                } 
                windows[w_index].curs_x  = 1; 
                windows[w_index].curs_xs = windows[w_index].curs_x; 
                windows[w_index].curs_y++; 
                windows[w_index].doc_x = 0; 
                start_y = windows[w_index].doc_y / hzeich; 
                doc_h   = windows[w_index].work.g_h / hzeich; 
                if (windows[w_index].curs_y > start_y + doc_h) 
                {                                 /* 2. if start  */ 
                  windows[w_index].doc_y += hzeich * doc_h/2; 
                  a = windows[w_index].doc_length - 
                        windows[w_index].work.g_h; 
                  a = max (a, 0); 
                  b = windows[w_index].doc_y; 
                  windows[w_index].doc_y = min (a, b); 
                  start_y_new = windows[w_index].doc_y / hzeich; 
                  if (windows[w_index].curs_y > start_y_new + doc_h) 
                  {                               /* 3. if start  */ 
                    if (windows[w_index].doc_length / hzeich < 
                        start_y_new + doc_h) 
                    { 
                      windows[w_index].curs_y = 
                        windows[w_index].doc_length / hzeich; 
                    } 
                    else 
                    { 
                      windows[w_index].curs_y = start_y_new + doc_h; 
                    } 
                  }                               /* 3. if end    */ 
                }                                 /* 2. if end    */ 
              } 
              else 
              { 
                doc_w   = windows[w_index].work.g_w / bzeich; 
                start_x = windows[w_index].doc_x / bzeich; 
                if (curs_x > start_x + doc_w) 
                { 
                  windows[w_index].doc_x += bzeich * doc_w/2; 
                  a = windows[w_index].doc_width - 
                        windows[w_index].work.g_w; 
                  a = max (a, 0); 
                  b = windows[w_index].doc_x; 
                  windows[w_index].doc_x = min (a, b); 
                  start_x_new = windows[w_index].doc_x / bzeich; 
                  if (curs_x > start_x_new + doc_w) 
                  { 
                    if (windows[w_index].doc_width / bzeich < 
                        start_x_new + doc_w) 
                    { 
                      windows[w_index].curs_x = 
                        windows[w_index].doc_width / bzeich; 
                    } 
                    else 
                    { 
                      windows[w_index].curs_x = start_x_new + doc_w; 
                    } 
                    windows[w_index].curs_xs  = 
                      windows[w_index].curs_x; 
                  } 
                } 
              }                                   /* 1. if end  */ 
              break; 
      case HI_CTCURIGHT:                  /* control cursor right */ 
              if (scan_lo != LO_CTCURIGHT) 
              { 
                cursor(w_handle, 1); 
  							graf_mouse(M_ON, NULL);
                return (TRUE); 
              } 
              len_x = line_length (w_index, 
                                   windows[w_index].curs_y); 
              windows[w_index].curs_x   = len_x; 
              windows[w_index].curs_xs  = windows[w_index].curs_x; 
              start_x = windows[w_index].doc_x / bzeich; 
              start_y = windows[w_index].doc_y / hzeich; 
              wind_w  = windows[w_index].work.g_w / bzeich; 
              wind_h  = windows[w_index].work.g_h / hzeich; 
              if ((windows[w_index].curs_y < start_y + 1)       || 
                  (windows[w_index].curs_y > start_y + wind_h)  || 
                  (windows[w_index].curs_x < start_x + 1)       || 
                  (windows[w_index].curs_x > start_x + wind_w)) 
              {                   /* cursor not within window area  */ 
                 windows[w_index].doc_x   = 
                   len_x - windows[w_index].work.g_w / bzeich; 
                 windows[w_index].doc_x   *= bzeich; 
                 windows[w_index].doc_x   = 
                   max ((long) windows[w_index].doc_x, (long) 0); 
              } 
              break; 
      case HI_CULEFT:                              /* cursor left  */ 
              windows[w_index].curs_x--; 
              windows[w_index].curs_xs = windows[w_index].curs_x; 
              curs_x = windows[w_index].curs_x; 
              if (curs_x < 1) 
              {                                   /* 1. if start  */ 
                if (windows[w_index].curs_y <= 1) 
                { 
                  windows[w_index].curs_x   = 1; 
                  windows[w_index].curs_xs  = windows[w_index].curs_x; 
                  cursor(w_handle, 1); 
  								graf_mouse(M_ON, NULL);
                  return (TRUE); 
                } 
                windows[w_index].curs_y--; 
                windows[w_index].curs_x = 
                  line_length (w_index, windows[w_index].curs_y); 
                windows[w_index].curs_xs = windows[w_index].curs_x; 
                start_y = windows[w_index].doc_y / hzeich; 
                doc_h   = windows[w_index].work.g_h / hzeich; 
                if (windows[w_index].curs_y <= start_y) 
                {                                 /* 2. if start  */ 
                  windows[w_index].doc_y -= hzeich * doc_h/2; 
                  windows[w_index].doc_y = 
                    max ((long) windows[w_index].doc_y, (long) 0); 
                  start_y_new = windows[w_index].doc_y / hzeich; 
                  if (windows[w_index].curs_y < start_y_new ) 
                  {                               /* 3. if start  */ 
                    windows[w_index].curs_y = start_y_new; 
                  }                               /* 3. if end    */ 
                }                                 /* 2. if end    */ 
                len_x = 
                  line_length (w_index, windows[w_index].curs_y); 
                windows[w_index].curs_x   = len_x; 
                windows[w_index].curs_xs  = windows[w_index].curs_x; 
                windows[w_index].doc_x    = 
                    len_x - windows[w_index].work.g_w / bzeich; 
                windows[w_index].doc_x    *= bzeich; 
                windows[w_index].doc_x    = 
                  max ((long) windows[w_index].doc_x, (long) 0); 
              } 
              else                                /* curs_x > 1   */ 
              { 
                doc_w   = windows[w_index].work.g_w / bzeich; 
                start_x = windows[w_index].doc_x / bzeich; 
                if (curs_x <= start_x) 
                { 
                  windows[w_index].doc_x -= bzeich * doc_w/2; 
                  a = windows[w_index].doc_x; 
                  windows[w_index].doc_x = max (a, 0); 
                  start_x_new = windows[w_index].doc_x / bzeich; 
                  if (curs_x < start_x_new) 
                  { 
                    windows[w_index].curs_x  = 
                      max ((long) start_x_new, (long) 0); 
                    windows[w_index].curs_xs = 
                      windows[w_index].curs_x; 
                  } 
                } 
              } 
              break; 
      case HI_CTCULEFT:                 /* control cursor left  */ 
              if (scan_lo != LO_CTCULEFT) 
              { 
                cursor(w_handle, 1); 
  							graf_mouse(M_ON, NULL);
                return (TRUE); 
              } 
              windows[w_index].curs_x   = 1; 
              windows[w_index].curs_xs  = windows[w_index].curs_x; 
              windows[w_index].doc_x = 0; 
              break; 
      case HI_DELETE:                                    /* delete */ 
							clear_block_flags (w_index);
              control = (int) ((Kbshift (-1) >> 2) & 0001);
                                /* is the control key pressed ? */
              if (!control)
              {
                jmc          = FALSE; 
                slider       = TRUE; 
                delete_space = TRUE; 
                curs_x = windows[w_index].curs_x; 
                p = line_ptr (w_index, windows[w_index].curs_y); 
                if ((p->next == NULL) && (curs_x == p->len)) 
                                                   /* end of text   */ 
                { 
                  p->line[curs_x-1] = ' ';
                  redraw_line = windows[w_index].curs_y;
                }
                else
                { 
                  curs_x--;            /* conceive it as an offset  */ 
                  for (i = curs_x; i < p->len; i++) 
                  {               /* shift letters, including '\0'  */ 
                    (p->line)[i] = (p->line)[i+1];
                  } 
                  curs_x++; 
                  if (curs_x - p->len != 0)     /* not end of line  */ 
                  {                                 /* 1. if start  */ 
                    p->len--; 
                    redraw_line = windows[w_index].curs_y; 
                    if  (
                      (p->len < 
                       windows[w_index].doc_width / bzeich - 1) || 
                      ((windows[w_index].doc_x == 0) && 
                      (p->len < 
                       windows[w_index].work.g_w / bzeich - 1))
                        ) 
                    { 
                      slider = FALSE; 
                    } 
                  } 
                  else                          /* end of line  */ 
                  { 
                    if ((p->next != NULL) && 
                       (p->len + p->next->len >= p->size - 2)) 
                    {                           /* 2. if start  */ 
                      cursor(w_handle, 1); 
  										graf_mouse(M_ON, NULL);
                      put_message (LINE_TOO_LONG); 
                      return (TRUE); 
                    } 
                    else              /* pull up the following line */ 
                    { 
                      q = p->next; 
                      strcpy (p->line + p->len - 1, q->line); 
                      p->len = (int) strlen (p->line); 
                                            /* calc new line length */ 
                      free ((char *) q->line);       /* free memory */ 
                      p->next = q->next; 
                      if (q->next != NULL) 
                      {                             /* 3. if start  */ 
                        (q->next)->prev = p; 
                      }                               /* 3. if end  */ 
                      free ((LINE_DESC *) q); 
                      windows[w_index].doc_length -= hzeich; 
                      from_line = windows[w_index].curs_y; 
                    }
                  }                                   
                }
                windows[w_index].modified = TRUE; 
                break;
              }
              else
              { 
                jmc         = FALSE; 
                slider      = TRUE; 
                curs_y_save = windows[w_index].curs_y; 
                curs_x = windows[w_index].curs_x; 
                p = line_ptr (w_index, windows[w_index].curs_y); 
                if (p->prev) 
                { 
                  (p->prev)->next = p->next;      /* may be NULL  */ 
                  if (p->next) 
                  { 
                    (p->next)->prev = p->prev;    /* may be NULL  */ 
                  } 
                  else                    /* delete the last line */ 
                  { 
                    (p->prev)->next = NULL; 
                    windows[w_index].curs_y--; 
                    start_y = windows[w_index].doc_y / hzeich; 
                    if (windows[w_index].curs_y <= start_y) 
                    { 
	                    send_buffer[0] = WM_ARROWED; 
	                    send_buffer[3] = w_handle; 
	                    send_buffer[4] = W_UPPAGE; 
	                    appl_write(ap_id, (short)sizeof(send_buffer), 
	                    					 send_buffer); 
                    } 
                  } 
                  free ((char *) p->line);  /* free mem for strings */ 
                  free ((LINE_DESC *) p); 
                } 
                else 
                { 
                  if (p->next) 
                  { 
                    windows[w_index].head = p->next;  /* never NULL */ 
                    (p->next)->prev = NULL; 
                    free ((char *) p->line);        /* free memory  */ 
                    free ((LINE_DESC *) p); 
                  } 
                  else                   /* this is the only line  */ 
                  { 
                    strcpy (p->line, " "); 
                    p->len = (int) strlen (p->line); 
                  } 
                } 
                windows[w_index].doc_length -= hzeich; 
                windows[w_index].doc_x   = 0; 
                windows[w_index].curs_x  = 1; 
                windows[w_index].curs_xs = windows[w_index].curs_x; 
                if (windows[w_index].curs_y > curs_y_save) 
                { 
                  from_line = windows[w_index].curs_y; 
                } 
                else 
                { 
                  from_line = curs_y_save; 
                } 
                windows[w_index].modified = TRUE; 
                break; 
              }   
      case HI_BACKSPACE:                            /* backspace  */ 
              jmc         = FALSE; 
              slider      = TRUE; 
              backspace   = TRUE; 
							clear_block_flags (w_index);
              curs_x = windows[w_index].curs_x; 
              p = line_ptr (w_index, windows[w_index].curs_y); 
              if ((p->prev == NULL) && (curs_x == 1)) 
                                                /* start of text  */ 
              { 
                cursor(w_handle, 1); 
  							graf_mouse(M_ON, NULL);
                return (TRUE); 
              } 
              if (curs_x > 1)               /* not start of line  */ 
              {                                   /* 1. if start  */ 
                curs_x--;            /* conceive it as an offset  */ 
                for (i = curs_x; i <= p->len; i++) 
                                                /* Note the "<="  */ 
                {                               /* shift letters, */ 
                  (p->line)[i-1] = (p->line)[i];/* including '\0' */ 
                } 
                p->len--; 
                p->len = (int) max ((long) p->len, (long) 1); 
                windows[w_index].curs_x--; 
                windows[w_index].curs_xs = windows[w_index].curs_x; 
                doc_w   = windows[w_index].work.g_w / bzeich; 
                start_x = windows[w_index].doc_x / bzeich; 
                if (curs_x <= start_x) 
                {                                /* 2. if start  */ 
                  windows[w_index].doc_x -= bzeich * doc_w/2; 
                  a = windows[w_index].doc_x; 
                  windows[w_index].doc_x = max (a, 0); 
                  start_x_new = windows[w_index].doc_x / bzeich; 
                  if (curs_x < start_x_new) 
                  { 
                    windows[w_index].curs_x   = 
                      max ((long) start_x_new, (long) 0); 
                    windows[w_index].curs_xs  = 
                      windows[w_index].curs_x; 
                  } 
                } 
                else 
                { 
                  redraw_line = windows[w_index].curs_y; 
                  if ((p->len < 
                        windows[w_index].doc_width / bzeich - 1) || 
                      ((windows[w_index].doc_x == 0) && 
                       (p->len < 
                        windows[w_index].work.g_w / bzeich - 1))) 
                  { 
                    slider = FALSE; 
                  } 
                }                                  /* 2. if end  */ 
              } 
              else                             /* start of line  */ 
              { 
                if ((p->prev != NULL) && 
                   (p->len + p->prev->len >= p->size - 2)) 
                {                                 /* 2. if start */ 
                  cursor(w_handle, 1); 
  								graf_mouse(M_ON, NULL);
                  put_message (LINE_TOO_LONG); 
                  return (TRUE); 
                } 
                else             /* pull up to the previous line */ 
                { 
                  q = p->prev; 
                  windows[w_index].curs_x  = q->len; 
                  windows[w_index].curs_xs = 
                    windows[w_index].curs_x; 
                  windows[w_index].curs_y--; 
                  strcpy (q->line + q->len - 1, p->line); 
                    q->len = (int) strlen (q->line); 
                  free ((char *) p->line); 
                  q->next = p->next; 
                  if (p->next != NULL) 
                  {                               /* 3. if start  */ 
                    (p->next)->prev = q; 
                  }                                 /* 3. if end  */ 
                  free ((LINE_DESC *) p); 
                  windows[w_index].doc_length -= hzeich; 
                  from_line = windows[w_index].curs_y; 
                  curs_x  = windows[w_index].curs_x; 
                  start_y = windows[w_index].doc_y / hzeich; 
                  doc_h   = windows[w_index].work.g_h / hzeich; 
                  if (windows[w_index].curs_y <= start_y) 
                  {                                /* 3. if start */ 
                    windows[w_index].doc_y -= hzeich * doc_h/2; 
                    windows[w_index].doc_y = 
                      max ((long) windows[w_index].doc_y, (long) 0); 
                    start_y_new = windows[w_index].doc_y / hzeich; 
                    if (windows[w_index].curs_y < start_y_new ) 
                    {                               /* 4. if start */ 
                      windows[w_index].curs_y = start_y_new; 
                    }                               /* 4. if end   */ 
                  }                                 /* 3. if end   */ 
                  windows[w_index].doc_x  = 
                      curs_x - windows[w_index].work.g_w / bzeich; 
                  windows[w_index].doc_x  *= bzeich; 
                  windows[w_index].doc_x  = 
                    max ((long) windows[w_index].doc_x, (long) 0); 
                }                                   /* 2. if end   */ 
              }                                     /* 1. if end   */ 
              windows[w_index].modified = TRUE; 
              break; 
      case HI_RETURN:                               /* return      */ 
              jmc         = FALSE; 
              slider      = TRUE; 
							clear_block_flags (w_index);
              curs_x = windows[w_index].curs_x; 
              p = line_ptr (w_index, windows[w_index].curs_y); 
              if ((q = create_list_element ()) == NULL) 
              { 
                cursor(w_handle, 1); 
  							graf_mouse(M_ON, NULL);
                put_message (OUT_OF_MEMORY); 
                return (TRUE); 
              } 
              curs_x--;                /* conceive it as an offset  */ 
              if ((q->line = (char *) malloc (MAX_LINE + 1)) == NULL) 
              { 
                free ((LINE_DESC *) q); 
                cursor(w_handle, 1); 
  							graf_mouse(M_ON, NULL);
                put_message (OUT_OF_MEMORY); 
                return (TRUE); 
              } 
              q->prev       = p;          /* update the linked list */ 
              q->next       = p->next; 
              if (q->next != NULL)  q->next->prev = q; 
              p->next       = q; 
              q->size = MAX_LINE; 
              memset (q->line, (int) 0, (size_t) (MAX_LINE -1)); 
              strcpy(q->line, (p->line)+curs_x); 
              q->len = (int) strlen (q->line); 
              (p->line)[curs_x]   = '\n'; 
              (p->line)[curs_x+1] = '\0'; 
              p->len = (int) strlen (p->line); 
              windows[w_index].doc_x   = 0; 
              windows[w_index].curs_x  = 1; 
              windows[w_index].curs_xs = windows[w_index].curs_x; 
              windows[w_index].curs_y++; 
              windows[w_index].doc_length += hzeich; 
              if (windows[w_index].curs_y - 1 > 0) 
              { 
                from_line = windows[w_index].curs_y - 1; 
              } 
              else 
              { 
                from_line = 0; 
              } 
              start_y = windows[w_index].doc_y / hzeich; 
              doc_h   = windows[w_index].work.g_h / hzeich; 
              if (windows[w_index].curs_y > start_y + doc_h) 
              { 
                windows[w_index].doc_y += hzeich * doc_h/2; 
                from_line = -1; 
              } 
              windows[w_index].modified = TRUE; 
              break; 
			case HI_ESC:				/* go to the beginning of the next word	*/
							if (scan_lo == LO_ESC)
							{
								find_next_word(w_index, &windows[w_index].curs_x,
																			  &windows[w_index].curs_y);
								windows[w_index].curs_xs = windows[w_index].curs_x;
								if (!cursor_visible_check(w_index))
								{
                  curs_y  = (windows[w_index].curs_y - 1) * hzeich; 
                  doc_h   = windows[w_index].work.g_h; 
                  windows[w_index].doc_y = max((long)curs_y - doc_h/2, (long)0); 
                  curs_x  = (windows[w_index].curs_x - 1) * bzeich; 
                  doc_w   = windows[w_index].work.g_w; 
                  if (!(windows[w_index].doc_x == 0 && curs_x + 1 <= doc_w)) 
                  { 
                    windows[w_index].doc_x = 
                    											max((long)curs_x - doc_w/2, (long)0); 
                  } 
                  send_buffer[0] = WM_REDRAW; 
                  send_buffer[3] = w_handle; 
                  send_buffer[4] = windows[w_index].work.g_x; 
                  send_buffer[5] = windows[w_index].work.g_y; 
                  send_buffer[6] = windows[w_index].work.g_w; 
                  send_buffer[7] = windows[w_index].work.g_h; 
                  appl_write(ap_id, (short)sizeof(send_buffer), send_buffer); 
                  cursor(w_handle, 1); 
  								graf_mouse(M_ON, NULL);
                  return (TRUE);  
								}
							}
							break;
      default:            /* deal with all the rest */ 
							clear_block_flags (w_index);
              jmc         = FALSE; 
              slider      = TRUE; 
              insert      = TRUE; 
              curs_x  = windows[w_index].curs_x; 
              shift   = 1; 
              if (((scan_lo >= LO_BLANK) && (scan_lo <= LO_TILDE)) || 
                  ((scan_lo == LO_TAB) && (scan_hi == HI_TAB))     || 
                   (scan_lo == LO_PARA)   || 
                   (scan_lo == LO_LAE)    || 
                   (scan_lo == LO_UAE)    || 
                   (scan_lo == LO_LUE)    || 
                   (scan_lo == LO_UUE)    || 
                   (scan_lo == LO_LOE)    || 
                   (scan_lo == LO_UOE)    || 
                   (scan_lo == LO_SZ)     || 
                   (scan_lo == LO_POUND)) 
              { 
                p = line_ptr (w_index, windows[w_index].curs_y); 
                if ((scan_lo == LO_TAB) && (scan_hi == HI_TAB)) 
                { 
                  if (tab_size == 0) 
                  { 
                    shift = 0; 
                  } 
                  else 
                  { 
                    shift   = 
                      (int) (tab_size - ((curs_x - 1) % tab_size)); 
                  } 
                  scan_lo = LO_BLANK;   /* "blank" will be inserted */ 
                  scan_hi = HI_BLANK; 
                } 
                if (p->len >= p->size - 1 - shift) 
                { 
                  cursor(w_handle, 1); 
  								graf_mouse(M_ON, NULL);
                  put_message (LINE_TOO_LONG); 
                  return (TRUE); 
                } 
                curs_x--;              /* conceive it as an offset  */ 
                for (i = 1; i <= shift; i++) 
                { 
                  for (j = p->len + 2; j > curs_x; j--) 
                  { 
                    (p->line)[j] = (p->line)[j-1]; 
                                                  /* shift letters  */ 
                  } 
                  (p->line)[curs_x] = (char) scan_lo; 
                                                  /* insert letter  */ 
                  windows[w_index].curs_x++; 
                  p->len++; 
                } 
                windows[w_index].curs_xs = windows[w_index].curs_x; 
                doc_w   = windows[w_index].work.g_w / bzeich; 
                start_x = windows[w_index].doc_x / bzeich; 
                curs_x  = windows[w_index].curs_x; 
                if (curs_x > start_x + doc_w) 
                { 
                  windows[w_index].doc_x += bzeich * doc_w/2; 
                } 
                else 
                { 
                  redraw_line = windows[w_index].curs_y; 
                  if ((p->len < 
                        windows[w_index].doc_width / bzeich - 1) || 
                      ((windows[w_index].doc_x == 0) && 
                       (p->len < 
                        windows[w_index].work.g_w / bzeich - 1))) 
                  { 
                    slider = FALSE; 
                  } 
                } 
              } 
              else 
              {                      /* "unsupported" keystrokes */ 
                cursor(w_handle, 1); 
  							graf_mouse(M_ON, NULL);
                return (TRUE);           /* nothing has happened */ 
              } 
              windows[w_index].modified = TRUE; 
              break; 
    }                                          /* 1. switch end  */ 
    /*  now the output is initiated */ 
    if ((doc_x_save != windows[w_index].doc_x)      || 
        (doc_y_save != windows[w_index].doc_y)      || 
        (doc_l_save != windows[w_index].doc_length) || 
        (doc_w_save != windows[w_index].doc_width)) 
    { 
      jmc     = FALSE; 
      slider  = TRUE; 
    } 
    if ((doc_x_save != windows[w_index].doc_x) || 
        (doc_y_save != windows[w_index].doc_y)) 
    { 
      if (!q_curs_down && !q_curs_up) 
      { 
        from_line   = -1; 
        redraw_line = -1; 
      } 
    } 
  }                                                /* 1. if end  */ 
  if (slider) 
  { 
    windows[w_index].doc_width  = 0; 
    windows[w_index].doc_length = 0; 
    for (p = windows[w_index].head; p != NULL; p = next) 
    { 
      next = p->next; 
      if (p->len * bzeich > windows[w_index].doc_width) 
      { 
        windows[w_index].doc_width = p->len * bzeich; 
      } 
      windows[w_index].doc_length += hzeich; 
    } 
    set_slider_size (w_handle); 
    set_slider_pos  (w_handle); 
  } 
  if (!jmc)        /* there's more to do than to move the cursor */ 
  {                                              /* 1. if start  */ 
    if (redraw_line == -1) 
                   /* there's more to redraw than just one line  */ 
    {                                            /* 2. if start  */ 
      if (from_line == -1)             /* whole redraw required  */ 
      {                                          /* 3. if start  */ 
        full_redraw (w_handle, TRUE); 
      } 
      else                       /* only partial redraw required */ 
      { 
        if (q_curs_down) 
        { 
          x = windows[w_index].work.g_x; 
          y = windows[w_index].work.g_y; 
          w = windows[w_index].work.g_w; 
          lines_copy = windows[w_index].work.g_h / hzeich; 
          lines_copy /= 2; 
          h = lines_copy * hzeich; 
          lines_redraw = 
            (int) ((windows[w_index].work.g_h - h) / hzeich); 
          rcopy ((int) x, (int) (y + lines_redraw * hzeich), 
                 (int) (w - 1), (int) (h - 1), 
                 (int) x, (int) y, (int) S_ONLY); 
          x = windows[w_index].work.g_x; 
          y = windows[w_index].work.g_y + lines_copy * hzeich; 
          w = windows[w_index].work.g_w; 
          h = lines_redraw * hzeich; 
          do_redraw ((int) w_handle, (int) x, (int) y, 
                     (int) w, (int) h, (int) TRUE); 
        } 
        else if (q_curs_up) 
        { 
          x = windows[w_index].work.g_x; 
          y = windows[w_index].work.g_y; 
          w = windows[w_index].work.g_w; 
          lines_copy = windows[w_index].work.g_h / hzeich; 
          lines_copy /= 2; 
          h = lines_copy * hzeich; 
          lines_redraw = 
            (int) ((windows[w_index].work.g_h - h) / hzeich); 
          rcopy ((int) x, (int) y, (int) (w - 1), (int) (h - 1), 
                 (int) x, (int) (y + lines_redraw * hzeich), 
                 (int) S_ONLY); 
          x = windows[w_index].work.g_x; 
          y = windows[w_index].work.g_y; 
          w = windows[w_index].work.g_w; 
          h = lines_redraw * hzeich; 
          do_redraw ((int) w_handle, (int) x, (int) y, 
                     (int) w, (int) h, (int) TRUE); 
        } 
        else 
        { 
          start_y = windows[w_index].doc_y / hzeich; 
          x = windows[w_index].work.g_x; 
          y = windows[w_index].work.g_y + 
                (from_line - 1 - start_y) * hzeich; 
          w = windows[w_index].work.g_w; 
          h = windows[w_index].work.g_h; 
          do_redraw ((int) w_handle, (int) x, (int) y, 
                     (int) w, (int) h, (int) TRUE); 
        } 
      }                                         /* 3. if end      */ 
    } 
    else                /* there's exactly one line to be redrawn */ 
    { 
      start_x = windows[w_index].doc_x / bzeich; 
      start_y = windows[w_index].doc_y / hzeich; 
      if (insert) 
      {                                         /* 3. if start    */ 
        help  = 
          (windows[w_index].curs_x - shift - start_x - 1) * bzeich; 
        help  = max ((long) help, (long) 0); 
        x     = windows[w_index].work.g_x + help; 
        help  = (redraw_line - 1 - start_y) * hzeich; 
        help  = max ((long) help, (long) 0); 
        y     = windows[w_index].work.g_y + help; 
        w     = windows[w_index].work.g_w + 
                  windows[w_index].work.g_x - x; 
        rcopy ((int) x, (int) y, (int) (w - shift * bzeich - 1), 
               (int) (hzeich - 1), (int) (x + shift * bzeich), 
               (int) y, (int) S_ONLY); 
        do_redraw ((int) w_handle, (int) x, (int) y, 
                   (int) (shift * bzeich), (int) hzeich, 
                   (int) TRUE); 
      } 
      else if (delete_space) 
      { 
        help  = (windows[w_index].curs_x - start_x - 1) * bzeich; 
        help  = max ((long) help, (long) 0); 
        x     = windows[w_index].work.g_x + help; 
        help  = (redraw_line - 1 - start_y) * hzeich; 
        help  = max ((long) help, (long) 0); 
        y     = windows[w_index].work.g_y + help; 
        w     = windows[w_index].work.g_w + 
                  windows[w_index].work.g_x - x; 
        rcopy ((int) (x + bzeich), (int) y, (int) (w - bzeich - 1), 
               (int) (hzeich - 1), (int) x, (int) y, (int) S_ONLY); 
        p = line_ptr (w_index, windows[w_index].curs_y); 
        if (p->len + 1 >= windows[w_index].work.g_w / bzeich) 
        { 
          do_redraw ((int) w_handle, (int) (x + w - 2*bzeich), 
          					 (int) y, (int) (2*bzeich), (int) hzeich, 
                     (int) TRUE); 
        } 
      } 
      else if (backspace) 
      { 
        help  = (windows[w_index].curs_x - start_x - 1) * bzeich; 
        help  = max ((long) help, (long) 0); 
        x     = windows[w_index].work.g_x + help; 
        help  = (redraw_line - 1 - start_y) * hzeich; 
        help  = max ((long) help, (long) 0); 
        y     = windows[w_index].work.g_y + help; 
        w     = windows[w_index].work.g_w + 
                  windows[w_index].work.g_x - x; 
        rcopy ((int) (x + bzeich), (int) y, (int) (w - bzeich - 1), 
               (int) (hzeich - 1), (int) x, (int) y, (int) S_ONLY); 
        p = line_ptr (w_index, windows[w_index].curs_y); 
        if (p->len + 1 >= windows[w_index].work.g_w / bzeich) 
        { 
          do_redraw ((int) w_handle, (int) (x + w - 2*bzeich), 
          					 (int) y, (int) (2*bzeich), (int) hzeich, 
                     (int) TRUE); 
        } 
      } 
      else       /* for any other situation this is the default  */ 
      { 
        x     = windows[w_index].work.g_x; 
        help  = (redraw_line - 1 - start_y) * hzeich; 
        help  = max ((long) help, (long) 0); 
        y     = windows[w_index].work.g_y + help; 
        w     = windows[w_index].work.g_w; 
        do_redraw ((int) w_handle, (int) x, (int) y, (int) w, 
        					 (int) hzeich, (int) TRUE); 
      }                                            /* 3. if end  */ 
    }                                              /* 2. if end  */ 
  }                                                /* 1. if end  */ 
  if (windows[w_index].modified == TRUE && 
      windows[w_index].wind_name[0] != MOD_CHAR) 
  { 
    for (i = (int) strlen (windows[w_index].wind_name) + 1; 
         i > 0; i--) 
    { 
      (windows[w_index].wind_name)[i] =    /* shift the letters   */ 
          (windows[w_index].wind_name)[i-1]; 
    } 
    (windows[w_index].wind_name)[0] = MOD_CHAR; 
                                         /* mark text as modified  */ 
    wind_set(w_handle, WF_NAME,         /* set the window name    */ 
           	 HighWord(windows[w_index].wind_name), 
            	(short)(windows[w_index].wind_name), 0, 0); 
  } 
  cursor(w_handle, 1);           /* show the text cursor ...  */ 
  graf_mouse(M_ON, NULL);
  return (TRUE); 
}                             /* end function handle_keybd     */ 
 
/* end of file keybd.c */ 
 
