/* 
replace.c 
ALICE V 2.0, January 1993
function for string replacement
(C) Ralf Kaufmann 1993
used C compiler: Pure C 
*/ 
 
/* Includefiles */ 
 
#define __GEMLIB_OLDNAMES
#include <gem.h> 
#include <stdio.h> 
#include <string.h> 
#include "language.h" 
#include "prvdef.h"
#include "mewidi.h" 
#include "messages.h" 
#include "scancode.h" 
#include "structs.h" 
#include "rsc.h" 
 
 
/* References to global data defined elsewhere  */ 
 
extern  short     ap_id, VDIhandle; 
extern  short     bzeich, hzeich; 
extern  WIND_DATA windows[]; 
extern  BUFFER    buffers[]; 
extern  OBJECT    *menu_tree; 
extern  OBJECT    *dial_about, *dial_help, *dial_print, *dial_tab; 
extern  OBJECT    *dial_search, *dial_replace, *dial_goto; 
extern  OBJECT    *dial_info, *dial_selebuf, *dial_linelen; 
extern  OBJECT    *dial_repl_info; 

extern  int  page_length, left_margin; 
extern  int  tab_size, backup, clocky, header, lines;
extern  int  showcr, showpos; 
extern  char param_filename[FSEL_MAX_PATH_LEN+FSEL_MAX_FILNAM_LEN]; 
extern  long param_line; 
extern  int  buffer_index;
extern  int  line_len, eol_warn; 

extern  int  sea_direct, sea_direct_cfg;
extern  int  sea_case, sea_case_cfg;
extern  int  sea_start, sea_start_cfg;
extern  int  repl_case, repl_case_cfg;
extern  int  repl_verify, repl_verify_cfg;
extern  int  repl_start, repl_start_cfg;

extern  char  sea_str[], sea_str_cfg[];
extern  char  repl_str[], repl_str_cfg[];
extern  char  replby_str[], replby_str_cfg[];
 
// Funktionsprorotypen
short block_set(short w_index); 
short cursor(short w_handle, short mode); 
short cursor_visible_check(short w_index); 
short do_redraw(short w_handle, short x, short y, short w, short h, 
								short clear); 
short full_redraw(short w_handle, short clear); 
short get_index_from_handle(short w_handle); 
short handle_dial(OBJECT *dial_tree, short start_obj); 
int line_length(int w_index, long number); 
LINE_DESC *line_ptr(int w_index, size_t number); 
long max(long a, long b);
int own_top_wind(void); 
void put_message(int msg_nr);
void refresh_window(int w_handle);
void repl_message(long count); 
int search(int w_index, long search_start_x, long search_start_y, 
           int search_direction, char *search_string, int search_case, 
           long *found_x, long *found_y); 
void set_slider_pos(short w_handle);
void set_slider_size(short w_handle); 
int top_wind(void); 

/**********************/ 
/* Start of routines  */ 
/**********************/ 
 
 
/* main routine for handling string replacement */ 
 
int do_replace(void) 
{ 
  char  search_string       [WD_MAX_EDIT_LENGTH]; 
  char  repl_string         [WD_MAX_EDIT_LENGTH]; 
  char  search_string_save  [WD_MAX_EDIT_LENGTH]; 
  char  repl_string_save    [WD_MAX_EDIT_LENGTH]; 
  char  help_str            [MAX_LINE]; 
     
  SHORT       scan_lo; 

  long        start_y, redraw_line; 
  long        x, y, w; 
  long        curs_x, curs_y, doc_w, doc_h; 
  long        len_1, len_2;
  long        search_start_x, search_start_y, diff; 
  long        found_x, found_y; 
  long        repl_count; 
  long        help; 
  int         key, ok, i, replaced = 0;
  int         verify; 
  int         w_handle, w_index, item_hit; 
  int         search_direction, cancel, eot; 
  int         found, first_entry; 
  int         send_buffer[MSG_BUFFER]; 
  int         replace_start_save, replace_verify_save;
  int         replace_case, replace_case_save;
  
  
  LINE_DESC   *p, *next; 
  TEDINFO     *ted_info; 
 

  if ((w_handle = top_wind ()) == -1) return (FALSE); 
  w_index = get_index_from_handle(w_handle); 
  if (w_index == -1 || !own_top_wind()) return (FALSE); 

  if (block_set (w_index)) 
  { 
    put_message (CANCEL_BLMARKS); 
    return (FALSE); 
  } 

  ted_info = dial_replace[REPLSTRG].ob_spec.tedinfo; 
  strcpy (search_string_save, ted_info->te_ptext); 
  ted_info = dial_replace[REPLBYST].ob_spec.tedinfo; 
  strcpy (repl_string_save, ted_info->te_ptext); 
  replace_start_save =  
    (dial_replace[REPLTOP].ob_state == SELECTED); 
  replace_case_save =  
    (dial_replace[RCASEYES].ob_state == SELECTED); 
  replace_verify_save =  
    (dial_replace[REPLVYES].ob_state == SELECTED); 
    

  item_hit = handle_dial (dial_replace, REPLSTRG); 
  refresh_window (w_handle);
  if (item_hit == REPLCANC) 
  {                     /* restore previous settings  */
    ted_info = dial_replace[REPLSTRG].ob_spec.tedinfo; 
    strcpy (ted_info->te_ptext, search_string_save); 
    ted_info = dial_replace[REPLBYST].ob_spec.tedinfo; 
    strcpy (ted_info->te_ptext, repl_string_save); 
    if (replace_start_save)
    {
      objc_change (dial_replace, REPLTOP,  
                    0, 0, 0, 0, 0, SELECTED, 0); 
      objc_change (dial_replace, REPLCURS,  
                    0, 0, 0, 0, 0, NORMAL, 0); 
    }
    else
    {
      objc_change (dial_replace, REPLCURS,  
                    0, 0, 0, 0, 0, SELECTED, 0); 
      objc_change (dial_replace, REPLTOP,  
                    0, 0, 0, 0, 0, NORMAL, 0); 
    }

    if (replace_case_save)
    {
      objc_change (dial_replace, RCASEYES,  
                    0, 0, 0, 0, 0, SELECTED, 0); 
      objc_change (dial_replace, RCASENO,  
                    0, 0, 0, 0, 0, NORMAL, 0); 
    }
    else
    {
      objc_change (dial_replace, RCASENO,  
                    0, 0, 0, 0, 0, SELECTED, 0); 
      objc_change (dial_replace, RCASEYES,  
                    0, 0, 0, 0, 0, NORMAL, 0); 
    }

    if (replace_verify_save)
    {
      objc_change (dial_replace, REPLVYES,  
                    0, 0, 0, 0, 0, SELECTED, 0); 
      objc_change (dial_replace, REPLVNO,  
                    0, 0, 0, 0, 0, NORMAL, 0); 
    }
    else
    {
      objc_change (dial_replace, REPLVYES,  
                    0, 0, 0, 0, 0, SELECTED, 0); 
      objc_change (dial_replace, REPLVNO,  
                    0, 0, 0, 0, 0, NORMAL, 0); 
    }
    return (TRUE);
  } 
  memset (search_string, (int) 0, (size_t) (WD_MAX_EDIT_LENGTH));
  ted_info = dial_replace[REPLSTRG].ob_spec.tedinfo; 
  strcpy (search_string, ted_info->te_ptext); 
  memset (repl_string, (int) 0, (size_t) (WD_MAX_EDIT_LENGTH));
  ted_info = dial_replace[REPLBYST].ob_spec.tedinfo; 
  strcpy (repl_string, ted_info->te_ptext); 

  if (dial_replace[REPLTOP].ob_state == SELECTED) 
  { 
    search_start_x  = 1; 
    search_start_y  = 1; 
    sea_start       = TRUE;
  } 
  else                           /* radio buttons... */ 
  { 
    search_start_x  = windows[w_index].curs_x; 
    search_start_y  = windows[w_index].curs_y; 
    sea_start       = FALSE;
  } 
  replace_case = (dial_replace[RCASEYES].ob_state == SELECTED); 
  verify = (dial_replace[REPLVYES].ob_state == SELECTED);
  cancel  = FALSE; 
  eot     = FALSE; 
  first_entry       = TRUE; 
  search_direction  = 1; 
  repl_count = 0; 
  
  repl_case   = replace_case;
  repl_verify = verify;
  strcpy (repl_str,   search_string);
  strcpy (replby_str, repl_string);
  
  if ((len_1  = 
       (int) strlen (search_string)) == 0) 
  { 
    return (TRUE); 
  } 
  if ((len_2  = 
       (int) strlen (repl_string))   == 0) 
  { 
    return (TRUE); 
  } 
  diff  = max ((long) 0, (long) (len_2 - len_1)); 

  while (!cancel && !eot) 
  {                                /* 1. while start */ 
    MOUSE_IS_BUSY; 
    found_x = 1; 
    found_y = 1; 
    found = search (w_index, /* initiate the search  */ 
                    search_start_x, 
                    search_start_y, 
                    search_direction, 
                    search_string, 
                    replace_case,
                    &found_x, 
                    &found_y); 
    if (!found) 
    {                           /* 1. if start  */ 
      if (first_entry) 
      { 
        MOUSE_IS_ARROW; 
        put_message (STRING_NOT_FOUND); 
      } 
      else 
      { 
        MOUSE_IS_ARROW; 
        refresh_window (w_handle);
        repl_message (repl_count);

        /* send myself a full redraw message  */ 
        send_buffer[0] = WM_REDRAW; 
        send_buffer[1] = ap_id; 
        send_buffer[2] = 0; 
        send_buffer[3] = w_handle; 
        send_buffer[4] = windows[w_index].work.g_x; 
        send_buffer[5] = windows[w_index].work.g_y; 
        send_buffer[6] = windows[w_index].work.g_w; 
        send_buffer[7] = windows[w_index].work.g_h; 
        appl_write(ap_id, (short)sizeof(send_buffer), send_buffer); 
      } 
      eot = TRUE; 
    } 
    else 
    { 
		  graf_mouse(M_OFF, NULL);
      if (verify) cursor (w_handle, 0); 
      windows[w_index].curs_x  = found_x; 
      windows[w_index].curs_xs = found_x; 
      windows[w_index].curs_y  = found_y; 
      if (!cursor_visible_check(w_index)) 
      {                               /* 2. if start  */ 
        /* recalc the new document position */ 
        curs_y  = (windows[w_index].curs_y - 1) * hzeich; 
        doc_h   = windows[w_index].work.g_h; 
        windows[w_index].doc_y = 
          max ((long) curs_y - doc_h/2, (long) 0); 

        curs_x  = (windows[w_index].curs_x - 1) * bzeich; 
        doc_w   = windows[w_index].work.g_w; 
        if (!(windows[w_index].doc_x == 0 && curs_x + 1 <= doc_w)) 
        {                             /* 3. if start  */ 
          windows[w_index].doc_x = max((long)curs_x - doc_w/2, (long)0); 
        }                               /* 3. if end  */ 
        if (verify) 	full_redraw (w_handle, TRUE); 
        if (first_entry) first_entry = FALSE; 
      } 
      else if (first_entry) 
      { 
        if (verify) 
        { 
          full_redraw (w_handle, TRUE); 
          cursor (w_handle, 1); 
        } 
        first_entry = FALSE; 
      } 
      else 
      { 
        if (verify) cursor (w_handle, 1); 
      }                                 /* 2. if end  */ 

  		graf_mouse(M_ON, NULL);

      /* wait for user input  */ 

      ok = FALSE; 
      while (!ok) 
      {                            /* 2. while start */ 
        if (verify) 
        { 
          MOUSE_IS_ARROW; 
          key     = evnt_keybd (); 
          scan_lo = key & 0x00FF; 
        } 
        if (!verify                               || 
            scan_lo == (int) 'Y' || scan_lo == (int) 'y') 
        {                            /* 3. if start  */ 
          ok = TRUE; 
          repl_count++; 

          /* perform the string replacement */ 

          p = line_ptr (w_index, found_y); 
          if (p->len + diff > MAX_LINE - 2) 
          { 
            MOUSE_IS_ARROW; 
            put_message (LINE_TOO_LONG); 
            cancel = TRUE; 
          } 
          else 
          { 
            for (i = 0; i < MAX_LINE; i++)
            {
              help_str[i] = '\0';
            }
            strcpy (help_str, repl_string); 
            strcpy (help_str + len_2, 
                    p->line + found_x - 1 + len_1); 
            strcpy (p->line + found_x - 1, help_str); 
            p->len    = (int) strlen (p->line); 
            windows[w_index].modified = TRUE; 
            replaced  = TRUE; 
          } 
        } 
        else if (scan_lo == (int) 'N' || scan_lo == (int) 'n') 
        { 
          ok = TRUE;                   /* do nothing */ 
          replaced  = FALSE; 
        } 
        else if (scan_lo == (int) 'C' || scan_lo == (int) 'c') 
        {                      /* cancel replacement */ 
          cancel    = TRUE; 
          ok        = TRUE; 
          replaced  = FALSE; 
        } 
        else                   /* "unsupported" keys */ 
        { 
          MOUSE_IS_ARROW; 
          item_hit = handle_dial (dial_repl_info, 0); 
          refresh_window (w_handle);
          if (item_hit == RPINCANC) 
          {                          /* 4. if start  */ 
            cancel    = TRUE; 
            ok        = TRUE; 
            replaced  = FALSE; 
          } 
        }                             /* 3. if end  */ 
      }                             /* 2. while end */ 
      if (cancel) 
      { 
        repl_message (repl_count);

        /* send myself a full redraw message  */ 
        send_buffer[0] = WM_REDRAW; 
        send_buffer[1] = ap_id; 
        send_buffer[2] = 0; 
        send_buffer[3] = w_handle; 
        send_buffer[4] = windows[w_index].work.g_x; 
        send_buffer[5] = windows[w_index].work.g_y; 
        send_buffer[6] = windows[w_index].work.g_w; 
        send_buffer[7] = windows[w_index].work.g_h; 
        appl_write(ap_id, (short)sizeof(send_buffer), send_buffer); 
        continue; 
      } 
      if (verify && replaced) 
      { 
        /* redraw the line */ 
        start_y = windows[w_index].doc_y / hzeich; 
        redraw_line = windows[w_index].curs_y; 
        x = windows[w_index].work.g_x + 
              (found_x - 1) * bzeich - 
              windows[w_index].doc_x; 
        help = (redraw_line - 1 - start_y) * hzeich; 
        help = max ((long) help, (long) 0); 
        y = windows[w_index].work.g_y + help; 
        w = windows[w_index].work.g_w; 
        cursor (w_handle, 0); 
        do_redraw ((int) w_handle, 
                   (int) x, 
                   (int) y, 
                   (int) w, 
                   (int) hzeich, 
                   (int) TRUE); 
        cursor (w_handle, 1); 
      } 

      /* go on with the next replacement  */ 

      search_start_x = windows[w_index].curs_x + len_2; 
      search_start_y = windows[w_index].curs_y; 
      if (search_start_x >= 
        line_length (w_index, search_start_y) && 
        search_start_y != 
          windows[w_index].doc_length/hzeich) 
      {                               /* 2. if start  */ 
        search_start_x = 1; 
        search_start_y++; 
        if (windows[w_index].doc_length/hzeich < 
            search_start_y) 
        { 
          search_start_y = 
            windows[w_index].doc_length/hzeich; 
        } 
      }                                 /* 2. if end  */ 
      if (line_length (w_index, search_start_y) < 
          search_start_x) 
      { 
        search_start_x = 
          line_length (w_index, search_start_y); 
      } 
    }                                   /* 1. if end  */ 
    if ((search_start_y == 
         windows[w_index].doc_length/hzeich) && 
        (search_start_x == 
         line_length (w_index, search_start_y))) 
    { 
      MOUSE_IS_ARROW; 
      refresh_window (w_handle);
      MOUSE_IS_ARROW; 
      repl_message (repl_count);

      /* send myself a full redraw message  */ 
      send_buffer[0] = WM_REDRAW; 
      send_buffer[1] = ap_id; 
      send_buffer[2] = 0; 
      send_buffer[3] = w_handle; 
      send_buffer[4] = windows[w_index].work.g_x; 
      send_buffer[5] = windows[w_index].work.g_y; 
      send_buffer[6] = windows[w_index].work.g_w; 
      send_buffer[7] = windows[w_index].work.g_h; 
      appl_write(ap_id, (short)sizeof(send_buffer), send_buffer); 

      eot = TRUE; 
    } 
  }                              /* end of 1. while  */ 
  windows[w_index].doc_width  = 0; 
                     /* recalc doc width and length  */ 
  windows[w_index].doc_length = 0; 
                     /* before setting the sliders   */ 
  for (p = windows[w_index].head; p != NULL; p = next) 
  { 
    next = p->next; 
    if (p->len * bzeich > windows[w_index].doc_width) 
    { 
      windows[w_index].doc_width = p->len * bzeich; 
    } 
    windows[w_index].doc_length += hzeich; 
  } 
  set_slider_size (w_handle); 
  set_slider_pos  (w_handle); 

  return (TRUE);

}


/* end of file replace.c  */
