/* 
docinfo.c 
ALICE V 2.0, January 1993
library functions for displaying document information
(C) Ralf Kaufmann 1993
used C compiler: Pure C 
*/ 
 
/* Includefiles */ 
 
#define __GEMLIB_OLDNAMES
#include <gem.h> 
#include <stdio.h> 
#include "language.h" 
#include "prvdef.h" 
#include "mewidi.h" 
#include "messages.h" 
#include "scancode.h" 
#include "structs.h" 
#include "rsc.h" 
 
 
/* References to global data defined elsewhere  */ 
 
extern  WIND_DATA   windows[]; 
extern  OBJECT      *menu_tree; 
extern  OBJECT      *dial_info; 
extern  OBJECT      *dial_selebuf; 
extern  int         buffer_index; 


extern  char    text[]; 

// Funktionsprototypen
void buf_enable(int flag); 
int exist_buffer(void); 
int exist_wind(void); 
short handle_dial(OBJECT *dial_tree, short start_obj); 
int own_top_wind(void); 
void restore_buffer_names(void);
void save_buffer_names(void);

/**********************/ 
/* Start of routines  */ 
/**********************/ 
 
 
/* main routine for displaying document information */
 
void select_buffer(void) 
{ 
  short item_hit; 

  save_buffer_names ();
  item_hit = handle_dial(dial_selebuf, BUFNAM1);
  if (item_hit == CANCBUF)
  {
    restore_buffer_names ();
    objc_change (dial_selebuf, BUF1, 0, 0, 0, 0, 0, NORMAL, 0); 
    objc_change (dial_selebuf, BUF2, 0, 0, 0, 0, 0, NORMAL, 0); 
    objc_change (dial_selebuf, BUF3, 0, 0, 0, 0, 0, NORMAL, 0); 
    objc_change (dial_selebuf, BUF4, 0, 0, 0, 0, 0, NORMAL, 0); 
    objc_change (dial_selebuf, BUF5, 0, 0, 0, 0, 0, NORMAL, 0); 
    objc_change (dial_selebuf, BUF6, 0, 0, 0, 0, 0, NORMAL, 0); 
    objc_change (dial_selebuf, BUF7, 0, 0, 0, 0, 0, NORMAL, 0); 
    objc_change (dial_selebuf, BUF8, 0, 0, 0, 0, 0, NORMAL, 0); 
    objc_change (dial_selebuf, BUF9, 0, 0, 0, 0, 0, NORMAL, 0); 
    objc_change (dial_selebuf, BUF10,0, 0, 0, 0, 0, NORMAL, 0); 
    if (buffer_index == 0)
    {
      objc_change (dial_selebuf, BUF1,     
                   0, 0, 0, 0, 0, SELECTED, 0); 
    }
    if (buffer_index == 1)
    {
      objc_change (dial_selebuf, BUF2,     
                   0, 0, 0, 0, 0, SELECTED, 0); 
    }
    if (buffer_index == 2)
    {
      objc_change (dial_selebuf, BUF3,     
                   0, 0, 0, 0, 0, SELECTED, 0); 
    }
    if (buffer_index == 3)
    {
      objc_change (dial_selebuf, BUF4,     
                   0, 0, 0, 0, 0, SELECTED, 0); 
    }
    if (buffer_index == 4)
    {
      objc_change (dial_selebuf, BUF5,     
                   0, 0, 0, 0, 0, SELECTED, 0); 
    }
    if (buffer_index == 5)
    {
      objc_change (dial_selebuf, BUF6,     
                   0, 0, 0, 0, 0, SELECTED, 0); 
    }
    if (buffer_index == 6)
    {
      objc_change (dial_selebuf, BUF7,     
                   0, 0, 0, 0, 0, SELECTED, 0); 
    }
    if (buffer_index == 7)
    {
      objc_change (dial_selebuf, BUF8,     
                   0, 0, 0, 0, 0, SELECTED, 0); 
    }
    if (buffer_index == 8)
    {
      objc_change (dial_selebuf, BUF9,     
                   0, 0, 0, 0, 0, SELECTED, 0); 
    }
    if (buffer_index == 9)
    {
      objc_change (dial_selebuf, BUF10,      
                   0, 0, 0, 0, 0, SELECTED, 0); 
    }
  }
  else
  {
    if (dial_selebuf[BUF1].ob_state == SELECTED) 
    { 
      buffer_index = 0;
    }
    if (dial_selebuf[BUF2].ob_state == SELECTED) 
    { 
      buffer_index = 1;
    }
    if (dial_selebuf[BUF3].ob_state == SELECTED) 
    { 
      buffer_index = 2;
    }
    if (dial_selebuf[BUF4].ob_state == SELECTED) 
    { 
      buffer_index = 3;
    }
    if (dial_selebuf[BUF5].ob_state == SELECTED) 
    { 
      buffer_index = 4;
    }
    if (dial_selebuf[BUF6].ob_state == SELECTED) 
    { 
      buffer_index = 5;
    }
    if (dial_selebuf[BUF7].ob_state == SELECTED) 
    { 
      buffer_index = 6;
    }
    if (dial_selebuf[BUF8].ob_state == SELECTED) 
    { 
      buffer_index = 7;
    }
    if (dial_selebuf[BUF9].ob_state == SELECTED) 
    { 
      buffer_index = 8;
    }
    if (dial_selebuf[BUF10].ob_state == SELECTED) 
    { 
      buffer_index = 9;
    }
  }
  buf_enable (exist_buffer ());
  if (exist_buffer () && exist_wind () && own_top_wind ())
  {
  	menu_ienable (menu_tree, IBLPASTE, TRUE); 
  }
  else
  {
  	menu_ienable (menu_tree, IBLPASTE, FALSE); 
  }
  return;
}


/* end of file selectbf.c   */
