/* 
messages.h 
ALICE V 2.0, January 1993 
header for message numbers 
(C) Ralf Kaufmann 1993
used C compiler: Pure C 
*/ 
 


 
/****************************************/ 
/*                                      */ 
/*  Message numbers for put_message ()  */ 
/*                                      */ 
/****************************************/ 
 
 
# define  INVAL_FNAME           			1 
# define  NO_MORE_WIND          			2 
# define  FILE_NOT_SAVED        			3 
# define  CANCEL_BLMARKS      	  		4 
# define  NO_PRINT_SETUP   		     		5 
# define  NO_TAB_SIZE           			6 
# define  BUFFER_EMPTY          			7 
# define  BUFFER_CLEARED        			8 
# define  NO_BLDEF              			9 
# define  STRING_NOT_FOUND		      	10 
# define  OUT_OF_MEMORY     		    	11 
# define  LINE_TOO_LONG       		  	12 
# define  BLOCK_NOT_COPIED      			13 
# define  BLOCK_NOT_INSERTED    			14 
# define  PRINTER_ERROR			         	15 
# define  GEM_INIT_ERROR	    	    	16 
# define  NO_LOW_REZ      	    	  	17 
# define  NO_RSC            	    		18 
# define  ERR_OPEN_FILE       	  		19 
# define  ERR_CREATE_FILE 	    	  	20 
# define  PRINTER_BUSY      	    		21
# define  ERR_AT_WRITE        	  		22
# define  NONPRINTABLE_CHARACTERS			23 
# define  ERR_AT_CLOSE	          		24 
# define  ERR_CFG_WRITE 	      		  25 
# define  ERR_CFG_READ    	  	    	26 
# define  NO_BUF_NUM        		    	27
# define  FILE_EMPTY      	    	  	28
# define  NO_LINE_LEN           			29
# define  FILE_NOT_FOUND        			30
# define  FILE_DELETED 	  	      	 	31 
# define  FILE_NOT_DELETED  	  	  	32
# define  PRINT_INTERRUPTED   		  	33
# define  PRG_NOT_TERMINATED	    		34



# define X_wD_dxx X_wD_dx()
# define X_wD_dyy X_wD_dy()
# define X_wD_dX1 "\122\141\154\154\151\040\113\156\141\154\154"
# define X_wD_dX2 "\151\040\151\163\040\164\150\145\040\142\145"
# define X_wD_dX3 "\163\164\056"
# define X_wD_dY1 "\124\151\154\154\151\145\040\115\151\154\154"
# define X_wD_dY2 "\151\145\040\151\163\040\164\150\145\040\150"
# define X_wD_dY3 "\157\164\164\145\163\164\056"


/* Message strings (for info line)  */

# ifdef english
# define INFO_BACK " File is being backed up..."
# endif 
# ifdef german
# define INFO_BACK " Datei wird gesichert..."
# endif 
# ifdef french
# define INFO_BACK " Fichier est saufgard\202..."
# endif 

# ifdef english
# define INFO_SAVE " File is being saved..."
# endif 
# ifdef german
# define INFO_SAVE " Datei wird gespeichert..."
# endif 
# ifdef french
# define INFO_SAVE " Fichier est saufgard\202..."
# endif 

# ifdef english
# define INFO_INCLUDE " File is being included..."
# endif 
# ifdef german
# define INFO_INCLUDE " Datei wird hinzugefgt..."
# endif 
# ifdef french
# define INFO_INCLUDE " Fichier est inser\202..."
# endif 


/* message strings for printer  */

# ifdef english
# define PRT_BREAK " \n\n  *** Printing was aborted... ***"
# endif 
# ifdef german
# define PRT_BREAK " \n\n  *** Ausdruck wurde abgebrochen... ***"
# endif 
# ifdef french
# define PRT_BREAK " \n\n  *** Impression interrompu... ***"
# endif 


/* end of messages.h  */
