/* 
scancode.h 
ALICE V 2.0, January 1993
header for scan codes 
(C) Ralf Kaufmann 1993
used C compiler: Pure C 
*/ 
 
 
 
/* Scan codes for keyboard handling */ 
 
# define  HI_CLOCK    0x17          /* clock symbol */ 
# define  LO_CLOCK    0x09 
 
# define  HI_BLANK  0x39            /* blank  */ 
# define  LO_BLANK  0x20 
 
# define  HI_TILDE  0x2B            /* tilde  */ 
# define  LO_TILDE  0x7E 
 
# define  HI_DELETE 0x53            /* delete */ 
# define  LO_DELETE 0x7F 
 
# define  HI_CULEFT 0x4B            /* cursor left  */ 
# define  LO_CULEFT 0x00 
 
# define  HI_CTCULEFT 0x73          /* control cursor left  */ 
# define  LO_CTCULEFT 0x00 
 
# define  HI_CURIGHT  0x4D          /* cursor right */ 
# define  LO_CURIGHT  0x00 
 
# define  HI_CTCURIGHT  0x74        /* control cursor right */ 
# define  LO_CTCURIGHT  0x00 
 
# define  HI_CUDOWN 0x50            /* cursor down  */ 
# define  LO_CUDOWN 0x00 
 
# define  HI_CUUP 0x48              /* cursor up  */ 
# define  LO_CUUP 0x00 
 
# define  HI_SCULEFT  0x4B          /* shift cursor left  */ 
# define  LO_SCULEFT  0x34 
 
# define  HI_SCURIGHT 0x4D          /* shift cursor right */ 
# define  LO_SCURIGHT 0x36 
 
# define  HI_SCUDOWN  0x50          /* shift cursor down  */ 
# define  LO_SCUDOWN  0x32 
 
# define  HI_SCUUP  0x48            /* shift cursor up  */ 
# define  LO_SCUUP  0x38 
 
# define  HI_CLRHOME  0x47          /* Clr Home */ 
# define  LO_CLRHOME  0x00 
 
# define  HI_SCLRHOME 0x47          /* shift Clr Home */ 
# define  LO_SCLRHOME 0x37 
 
# define  HI_BACKSPACE  0x0E        /* backspace  */ 
# define  LO_BACKSPACE  0x08 
 
# define  HI_RETURN 0x1C            /* return */ 
# define  LO_RETURN 0x0D 
 
# define  HI_INSERT 0x52            /* insert */ 
# define  LO_INSERT 0x00 
 
# define  HI_SINSERT  0x52          /* shift insert */ 
# define  LO_SINSERT  0x30 
 
# define  HI_TAB      0x0F          /* TAB  */ 
# define  LO_TAB      0x09 
 
# define  HI_ESC      0x01          /* ESC  */ 
# define  LO_ESC      0x1B 
 
# define  HI_HELP   0x62            /* help */ 
# define  LO_HELP   0x00 
 
# define  HI_ALT_A 0x1E            /* ALT A   */ 
# define  LO_ALT_A 0x00 
 
# define  HI_ALT_B 0x30            /* ALT B   */ 
# define  LO_ALT_B 0x00 
 
# define  HI_ALT_C 0x2E            /* ALT C   */ 
# define  LO_ALT_C 0x00 
 
# define  HI_ALT_D 0x20            /* ALT D   */ 
# define  LO_ALT_D 0x00 
 
# define  HI_ALT_E 0x12            /* ALT E   */ 
# define  LO_ALT_E 0x00 
 
# define  HI_ALT_F 0x21            /* ALT F   */ 
# define  LO_ALT_F 0x00 
 
# define  HI_ALT_G 0x22            /* ALT G   */ 
# define  LO_ALT_G 0x00 
 
# define  HI_ALT_H 0x23            /* ALT H   */ 
# define  LO_ALT_H 0x00 
 
# define  HI_ALT_I 0x17            /* ALT I   */ 
# define  LO_ALT_I 0x00 
 
# define  HI_ALT_J 0x24            /* ALT J   */ 
# define  LO_ALT_J 0x00 
 
# define  HI_ALT_K 0x25            /* ALT K   */ 
# define  LO_ALT_K 0x00 
 
# define  HI_ALT_L 0x26            /* ALT L   */ 
# define  LO_ALT_L 0x00 
 
# define  HI_ALT_M 0x32            /* ALT M   */ 
# define  LO_ALT_M 0x00 
 
# define  HI_ALT_N 0x31            /* ALT N   */ 
# define  LO_ALT_N 0x00 
 
# define  HI_ALT_O 0x18            /* ALT O   */ 
# define  LO_ALT_O 0x00 
 
# define  HI_ALT_P 0x19            /* ALT P   */ 
# define  LO_ALT_P 0x00 
 
# define  HI_ALT_Q 0x10            /* ALT Q   */ 
# define  LO_ALT_Q 0x00 
 
# define  HI_ALT_R 0x13            /* ALT R   */ 
# define  LO_ALT_R 0x00 
 
# define  HI_ALT_S 0x1F            /* ALT S   */ 
# define  LO_ALT_S 0x00 
 
# define  HI_ALT_T 0x14            /* ALT T   */ 
# define  LO_ALT_T 0x00 
 
# define  HI_ALT_U 0x16            /* ALT U   */ 
# define  LO_ALT_U 0x00 
 
# define  HI_ALT_V 0x2F            /* ALT V   */ 
# define  LO_ALT_V 0x00 
 
# define  HI_ALT_W 0x11            /* ALT W   */ 
# define  LO_ALT_W 0x00 
 
# define  HI_ALT_X 0x2D            /* ALT X   */ 
# define  LO_ALT_X 0x00 
 
# define  HI_ALT_Y 0x2C            /* ALT Y   */ 
# define  LO_ALT_Y 0x00 
 
# define  HI_ALT_Z 0x15            /* ALT Z   */ 
# define  LO_ALT_Z 0x00 
 
# define  HI_CTRL_A 0x1E            /* CTRL A   */ 
# define  LO_CTRL_A 0x01 
 
# define  HI_CTRL_B 0x30            /* CTRL B   */ 
# define  LO_CTRL_B 0x02 

# define  HI_CTRL_D 0x20            /* CTRL D   */ 
# define  LO_CTRL_D 0x04 
 
# define  HI_CTRL_W 0x11            /* CTRL W   */ 
# define  LO_CTRL_W 0x17 
 
# define  HI_CTRL_I 0x17            /* CTRL I   */ 
# define  LO_CTRL_I 0x09 
 
# define  HI_CTRL_K 0x25            /* CTRL K   */ 
# define  LO_CTRL_K 0x0B 
 
# define  HI_CTRL_N 0x31            /* CTRL N   */ 
# define  LO_CTRL_N 0x0E 

# define  HI_CTRL_O 0x18            /* CTRL O   */ 
# define  LO_CTRL_O 0x0F 
 
# define  HI_CTRL_R 0x13            /* CTRL R   */ 
# define  LO_CTRL_R 0x12 
 
# define  HI_CTRL_F 0x21            /* CTRL F   */ 
# define  LO_CTRL_F 0x06 
 
# define  HI_CTRL_M 0x32            /* CTRL M   */ 
# define  LO_CTRL_M 0x0D 
 
# define  HI_CTRL_P 0x19            /* CTRL P   */ 
# define  LO_CTRL_P 0x10 
 
# define  HI_CTRL_L 0x26            /* CTRL L   */ 
# define  LO_CTRL_L 0x0C 
 
# define  HI_CTRL_S 0x1F            /* CTRL S   */ 
# define  LO_CTRL_S 0x13 
 
# define  HI_CTRL_E 0x12            /* CTRL E   */ 
# define  LO_CTRL_E 0x05 
 
# define  HI_CTRL_T 0x14            /* CTRL T   */ 
# define  LO_CTRL_T 0x14 
 
# define  HI_CTRL_B 0x30            /* CTRL B   */ 
# define  LO_CTRL_B 0x02 
 
# define  HI_CTRL_Z 0x15            /* CTRL Z   */ 
# define  LO_CTRL_Z 0x1A 
 
# define  HI_CTRL_Q 0x10            /* CTRL Q   */ 
# define  LO_CTRL_Q 0x11 
 
# define  HI_CTRL_X 0x2D            /* CTRL X   */ 
# define  LO_CTRL_X 0x18 
 
# define  HI_CTRL_C 0x2E            /* CTRL C   */ 
# define  LO_CTRL_C 0x03 
 
# define  HI_CTRL_V 0x2F            /* CTRL V   */ 
# define  LO_CTRL_V 0x16 
 
# define  HI_CTRL_U 0x16            /* CTRL U   */ 
# define  LO_CTRL_U 0x15 
 
# define  LO_PARA   0xDD        /* paragraph symbol   */ 
 
# define  LO_LAE    0x84        /* lowercase a umlaut */ 
# define  LO_UAE    0x8E        /* uppercase a umlaut */ 
 
# define  LO_LUE    0x81        /* lowercase u umlaut */ 
# define  LO_UUE    0x9A        /* uppercase u umlaut */ 
 
# define  LO_LOE    0x94        /* lowercase o umlaut */ 
# define  LO_UOE    0x99        /* uppercase o umlaut */ 
 
# define  LO_SZ     0x9E        /* german sz ()      */ 
 
# define  LO_POUND  0x9C        /* engl. pound sign   */ 
 
 
# define  HI_C      0x2E 
# define  LO_C      0x43 
 
# define  HI_J      0x24 
# define  LO_J      0x4A 
 
# define  HI_N      0x31 
# define  LO_N      0x4E 
 
# define  HI_Q      0x10 
# define  LO_Q      0x51 
 
# define  HI_Y      0x2C 
# define  LO_Y      0x59 
 
# define  HI_c      0x2E 
# define  LO_c      0x63 
 
# define  HI_j      0x24 
# define  LO_j      0x6A 
 
# define  HI_n      0x31 
# define  LO_n      0x6E 
 
# define  HI_q      0x10 
# define  LO_q      0x71 
 
# define  HI_y      0x2C 
# define  LO_y      0x79 
 
 
 
# define  HI_F1     0x3B            /* F1 */ 
# define  LO_F1     0x00 
 
# define  HI_F2     0x3C            /* F2 */ 
# define  LO_F2     0x00 
 
# define  HI_F3     0x3D            /* F3 */ 
# define  LO_F3     0x00 
 
# define  HI_F4     0x3E            /* F4 */ 
# define  LO_F4     0x00 
 
# define  HI_F5     0x3F            /* F5 */ 
# define  LO_F5     0x00 
 
# define  HI_F6     0x40            /* F6 */ 
# define  LO_F6     0x00 
 
# define  HI_F7     0x41            /* F7 */ 
# define  LO_F7     0x00 
 
# define  HI_F8     0x42            /* F8 */ 
# define  LO_F8     0x00 
 
# define  HI_F9     0x43            /* F9 */ 
# define  LO_F9     0x00 
 
# define  HI_F10    0x44            /* F10 */ 
# define  LO_F10    0x00 
 
 
# define  HI_SF1    0x54            /* Shift F1 */ 
# define  LO_SF1    0x00 
 
# define  HI_SF2    0x55            /* Shift F2 */ 
# define  LO_SF2    0x00 
 
# define  HI_SF3    0x56            /* Shift F3 */ 
# define  LO_SF3    0x00 
 
# define  HI_SF4    0x57            /* Shift F4 */ 
# define  LO_SF4    0x00 
 
# define  HI_SF5    0x58            /* Shift F5 */ 
# define  LO_SF5    0x00 
 
# define  HI_SF6    0x59            /* Shift F6 */ 
# define  LO_SF6    0x00 
 
# define  HI_SF7    0x5A            /* Shift F7 */ 
# define  LO_SF7    0x00 
 
# define  HI_SF8    0x5B            /* Shift F8 */ 
# define  LO_SF8    0x00 
 
# define  HI_SF9    0x5C            /* Shift F9 */ 
# define  LO_SF9    0x00 
 
# define  HI_SF10   0x5D            /* Shift F10 */ 
# define  LO_SF10   0x00 
 
 
/* end of scancode.h  */ 
 
